package Librerias;


public class FuncionesMatematicas {

    /*******************************************************************************
     *      Obtiene la multiplicacion entre 2 o más vectores y una vez             *
     *      multiplicados estos, se realiza la suma del vector resultante          *
     * @param vectorA: vector que contiene los datos que se procesarán             *
     * @param vectores: n número de vectores que se procesarán                     *
     * @return valor que contiene el resultado de la sumaProducto de los vectores  *
     *******************************************************************************/

    public double sumaProducto(double[] vectorA, double[]... vectores){
        double[] sumaProductoVec = new double[vectorA.length];
        double sumaProducto = 0;
        int index = 0;
        //leemos los vectores y realizamos suma
        //leemos el primer vector
        for (double va:vectorA){
            sumaProductoVec[index] = va;
            index++;
        }
        index=0;
        //leemos los demas vectores y los multiplicamos entre si
        for (double[] vector:vectores){
            for (double v:vector){
                if (index==vectorA.length){
                    break;
                }
                sumaProductoVec[index] *=  v;
                index++;
            }
            index = 0;
        }
        for (double sp:sumaProductoVec){
            sumaProducto += sp;
        }
        return sumaProducto;
    }

    public double sumaProductoDelimitado(double[] vectorA, double[] vectorB,int delimit){
        double[] sumaProductoVec = new double[vectorA.length];
        double sumaProducto = 0;

        //Multiplicamos cada celda de los vectores
        for(int celda=delimit;celda<sumaProductoVec.length;celda++){
            sumaProductoVec[celda]= vectorA[celda] * vectorB[celda];
        }
        //Sumamamos todas las celdas
        for (double sp:sumaProductoVec){
            sumaProducto += sp;
        }
        return sumaProducto;
    }


    /*********************************************************************
     * Suma el contenido de una matriz y lo almacena en un vector        *
     * @param matriz: que contiene los datos que se sumarán              *
     * @return vector que contiene la suma                               *
     *********************************************************************/
    public double[] sumaMatriz(double[][] matriz){
        double[] vector = new double[matriz.length];
        int index=0;

        //lee el vector de la matriz
        for (double[] v:matriz){
            //lee el valor de la celda
            for (double celda:v){
                vector[index] +=celda;
            }
            index++;
        }
        return vector;
    }


    /*********************************************************************
     * Suma el contenido de una matriz y lo almacena en un vector        *
     * @param matriz: que contiene los datos que se sumarán              *
     * @return vector que contiene la suma                               *
     *********************************************************************/
    public double[] sumaMatrizDelimitada(double[][] matriz, int delimit){//delimit debe ser apartir de donde se quiere leer
        double[] vector = new double[matriz.length];
        //int indexedad=0;
        //int ant = delimit;
        
        for(int edad=0;edad<matriz.length;edad++){
            for(int ant=delimit;ant<matriz[0].length;ant++){
                vector[edad]+=matriz[edad][ant];
            }
        }
        return vector;
    }

    /*********************************************************************
     *                  Suma el contenido de un vector                   *
     * @param vector: Contiene los datos que se van a suamr              *
     * @return valor que contiene el resultado de la suma del vector     *
     *********************************************************************/

    public double sumaVector(double[] vector){
        double resultado=0;

        for(double suma:vector ){
            resultado += suma;
        }
        return resultado;
    }

    public double sumaVectorDelimitado(double[] vector, int delimit){
        double resultado=0;

        for(int i=delimit;i<vector.length;i++){
            resultado+=vector[i];
        }
        return resultado;
    }

    /**********************************************************************
     *             Transpone los datos contenidos en una matriz           *
     * @param matriz: contiene los datos a procesar                       *
     * @return matriz con las datos transpuestos                          *
     **********************************************************************/
    public double[][] transponer(double[][] matriz){
        double[][] matrizTranspuesta= new double[matriz[0].length][matriz.length];
        int columna=0;
        int linea=0;

        for( double[] vec:matriz){
            for(double celda:vec){
                matrizTranspuesta[linea][columna] = celda;
                linea++;
            }
            columna++;
            linea=0;
        }
        return matrizTranspuesta;
    }

    public double[][] delimitarMatriz(double[][] matriz,
                                      int delimit){

        double matrizdelimitada[][] = new double[matriz.length][matriz[0].length];

        for(int y=0;y<matrizdelimitada.length;y++){
            for(int x=delimit;x<matrizdelimitada[0].length;x++){
                matrizdelimitada[y][x] = matriz[y][x];
            }
        }
        return matrizdelimitada;
    }

    public double[][] redimensionarMatriz(double[][] matriz,
                                          int dim1,
                                          int dim2,
                                          int limiteInf){

        double[][] matrizRedim = new double[dim1][dim2];

        for(int y=0;y<matrizRedim.length;y++){
            for(int x=0;x<matrizRedim[0].length;x++){
                matrizRedim[y][x] = matriz[y][limiteInf+x];
            }
        }
        return matrizRedim;

    }


    
}
