package Librerias;

import java.util.*;
import java.io.*;

public class LecturaArchivoTxt {

    /*************************************************************************************
     * Este metodo permite leer un archivo txt y obtener los parámetros especificados    *
     * @param ruta: Ruta donde se encuentra el archivo txt                               *
     * @param nombreArchivo: Nombre del archivo txt que se va abrir                      *
     * @return array tipo object                                                         *
     *************************************************************************************/

    public Object[] leerArchivoParametros(String rutaArchivo, String nombreArchivo){
        File archivoLeer = null;
        FileReader fr = null;
        ArrayList lineaAlmacenar = new ArrayList();
        Object[] vector = null;

        try{
            archivoLeer = new File(rutaArchivo+nombreArchivo);
            String lecturaLinea;
            String[] parametros;
            fr = new FileReader(archivoLeer);
            BufferedReader br = new BufferedReader(fr);

            while ((lecturaLinea=br.readLine())!=null){
                
                if (!lecturaLinea.equals("") && !lecturaLinea.startsWith("//")){
                    parametros = lecturaLinea.split("#");
                    if (parametros[1].trim().matches("\\d*+\\.+\\d*")){
                        lineaAlmacenar.add(parametros[1]);
                        
                    }else if (parametros[1].trim().matches("\\d*")){
                        lineaAlmacenar.add(parametros[1]);
                        
                    }else if (parametros[1].trim().matches("\\w*")){
                        lineaAlmacenar.add(parametros[1]);
                        
                    }else{
                        lineaAlmacenar.add(parametros[1]);
                        
                        
                    }
                }
            }//fin del while
            vector = lineaAlmacenar.toArray();

            
        }catch(IOException e){
            System.out.println(e);
        }finally{
            try{
                if (fr!=null){
                    fr.close();
                }
            }catch(IOException e){

            }
        }

        return vector;
    }

    /*********************************************************************************************
     *      Verifica que exista un archivo, en caso de no existir lo crea                        *
     * @param ruta: Ruta donde se encuentra el archivo txt                                       *
     * @param nombreArchivo: Nombre del archivo txt que se va abrir                              *
     * @param eliminarArchivo: boolean que indica si se elimina el archivo en caso de existir    *
     * @return array tipo object                                                                 *
     *********************************************************************************************/
    public boolean existeArchivo(String ruta,String nombreArchivo,boolean eliminarArchivo){
        File archivo = null;

        try{
            archivo = new File(ruta+nombreArchivo);
            if (archivo.exists()){
                if (eliminarArchivo){
                    archivo.delete();
                }
                return true;
            }
        }catch(Exception e){
            return false;
        }
        return false;
    }

    public boolean existeArchivo(String ruta,String nombreArchivo){
        File archivo = null;

        try{
            archivo = new File(ruta+nombreArchivo);
            if (archivo.exists()){                
                return true;
            }else{
                return false;
            }
        }catch(Exception e){
            System.out.println(e);
            return false;
        }        
    }

}
