    /*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ProyeccionPensionados;

/**
 *
 * @author Antonio-Alcalde
 */

import SIV.ProyeccionSIV;
import SIV.ProyeccionStockSIV;
import SRT.ProyeccionSRT;
import SRT.StockSRT;

public class Main {

    public static void main(String[] args) {

        /*********************************************
         * Para tipo de pensión las opciones son:    *
         * IV para Seguro de Invalidez y Vida        *
         * RT para Seguro de Riesgos de Trabajo      *
         * AM para ambos                             *
         *********************************************/

        String seguro = "AM";

        /************************************
         * Para el sexo las opciones son:   *
         * H para Hombres                   *
         * M para Mujer                     *
         * AM para ambos                    *
         ************************************/

        //Por default se cargan los siguientes parametros

        String sexo = "AM";
        String ruta = "../";
        String fileNameParam = "ContantesCostoFiscal.txt";

        // Verifica que en metodo main se reciben parametros de entrada
        if (args.length > 0) {
            ruta = args[0];
            fileNameParam = args[1];
            seguro = args[2];
            sexo = args[3];            

        }

        //Creamos los objetos que se requieren para las proyecciones.
        ProyeccionSIV psiv = new ProyeccionSIV();
        Constantes ccp = new Constantes(ruta, fileNameParam);
        ProyeccionSRT psrt = new ProyeccionSRT();
        ProyeccionStockSIV stockIV = new ProyeccionStockSIV();
        StockSRT stockRT = new StockSRT();
        
        /********************************
         * Validamos si se ejecuta IV   *
         ********************************/
        if (seguro.equals("IV") || seguro.equals("AM")) {
            if (sexo.equals("H") || sexo.equals("AM")) {
                System.out.println("Proyectando Costo Fiscal SIV Hombres");
                psiv.obtenerFuturosPensionadosSIV(Constantes.HOMBRE,"IV");
                stockIV.obtenerStockSIV(Constantes.HOMBRE, seguro);
            }
            if (sexo.equals("M") || sexo.equals("AM")) {
                System.out.println("Proyectando Costo fiscal SIV Mujeres");
                psiv.obtenerFuturosPensionadosSIV(Constantes.MUJER,"IV");
                stockIV.obtenerStockSIV(Constantes.MUJER, seguro);
            }

        }//fin para el SIV

        /**********************************
         * Validamos si se ejecuta RT     *
         **********************************/

        if (seguro.equals("RT") || seguro.equals("AM")) {
            if (sexo.equals("H") || sexo.equals("AM")) {
                System.out.println("Proyectando Costo Fiscal SRT Hombres");
                psrt.obtenerFuturosPensionadosSRT(Constantes.HOMBRE,"RT");
                stockRT.obtenerStockSRT(Constantes.HOMBRE, seguro);
            }
            if (sexo.equals("M") || sexo.equals("AM")) {
                System.out.println("Proyectando Costo Fiscal SRT Mujeres");
                psrt.obtenerFuturosPensionadosSRT(Constantes.MUJER,"RT");
                stockRT.obtenerStockSRT(Constantes.MUJER, seguro);
            }
        }

        System.out.println("Han terminado las proyecciones del Costo Fiscal derivado de las pensiones");
    }
}
