/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package SIV;

/**
 *
 * @author Antonio-Alcalde
 */
import ProyeccionPensionados.CuentaIndividual;
import ProyeccionPensionados.ProyeccionDemografica;
import ProyeccionPensionados.ProyeccionFinanciera;
import ProyeccionPensionados.Constantes;
import Librerias.*;


public class ProyeccionSIV {

    public void obtenerFuturosPensionadosSIV(char sexo,String seguro) {

        
        double[][] asegbase;
        double[][] probSobrevivenciaAseg;
        double[][] probEntradaPension;
        double[][] distViudas;
        double[][] distOrfandad;
        double[][] distAscendientes;
        double[][] salariosHistoricos;
        double[][] art167LSS;
        double[][] saldoRCVL73;
        double[][] saldoCSL73;
        double[][] saldoVivL73;        
        double[][] asegVig = null;
        double[][] proyRCV = null;
        double[][] proyCS = null;
        double[][] proyViv = null;

        double[][] probMteCMGInv;
        double[] densidadCotizacion;
        double[] ERdef73;
        double[] ERTemp73;
        double[] ERTemDef73;
        double[] ERMte73;
        double[] ERCeve73;
        double[] probMteCMGActDerivadas;
        double[] probMteCMGActTitCeVe;        
        double[] tasasMejoraDerivadas;
        double[] tasasMejoraTitulares;
        double[] tasasDesercion;
        double[] incrementoRealSalarios;
        double[] inflacionAnual;
        double[] incRealSalMin;
        double[] salarioReal;
        double[] rangoSalariosCuotaSocial;
        double[] comisionSobreSaldo;
        double[] tasaBimestralRCVyCS;
        double[] tasaBimestralVivienda;
        double[] tasaAnualRCVyCS;
        double[] tasaAnualVivienda;
        double[] capitalizacionAportRCVyCS;
        double[] capitalizacionAportViv;


        double[][] resumenInvalidez = new double[Constantes.ANIOS_PROYECCION][33];
        double[][] resumenCeVe = new double[Constantes.ANIOS_PROYECCION][12];
        double[][] resumenMte = new double[Constantes.ANIOS_PROYECCION][10];

        /***************************************************************************************************
         *   Direccion en la que se encuentran los archivos, que el programa va tomar para procesarlos.     *
         ****************************************************************************************************/
        String directorioArchivoEntradas = Constantes.DIRECTORIO_DATOS_ENTRADA;
        String directorioFormato = Constantes.DIRECTORIO_FORMATO;
        String directorioSalida = Constantes.DIRECTORIO_SALIDA;
        String archivoEntradas = Constantes.NOMBRE_ARCHIVO_ENTRADA;
        String archivoSalida = Constantes.NOMBRE_ARCHIVO_SALIDA_IV;
        String archivoFormato = Constantes.NOMBRE_ARCHIVO_FORMATO_IV;
                
        /************************************************************************
         *    Se crean los objetos que se requieren en la proyeccion del SIV    *
         ************************************************************************/
        LecturaEscrituraHojasCalculo lecEscHojCalc = new LecturaEscrituraHojasCalculo();
        ProyeccionDemografica pa = new ProyeccionDemografica();
        ProyeccionFinanciera pf = new ProyeccionFinanciera();
        FuncionesMatematicas fm = new FuncionesMatematicas();
        CuentaIndividual ci = new CuentaIndividual();
        LecturaArchivoTxt latxt = new LecturaArchivoTxt();      

        /*************************************************************************
         *Obtención de parametros de entrada del SIV para realizar la proyección *
         *************************************************************************/

        lecEscHojCalc.abrirArchivoExcel(directorioArchivoEntradas,archivoEntradas, ".xls");

        if(sexo == Constantes.HOMBRE){
            
            asegbase = (double[][]) lecEscHojCalc.leerHojaExcel("PoblacionAsegBaseIV", 2, 2, 51, 75);//ok
            densidadCotizacion = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 4, 2, 75);//ok
            probSobrevivenciaAseg = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemIV", 4, 3, 75, 3);//ok
            //probabilidad Entrada pension: 0 = invalidez, 1 = ceve , 2 = mte enf genral
            probEntradaPension = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemIV", 4, 6, 75, 3);//ok
            ERdef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 4, 11, 100);//ok
            ERTemp73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 4, 12, 100);//ok
            ERTemDef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 4, 13, 100);//ok
            ERMte73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 4, 14, 100);//ok
            ERCeve73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 4, 15, 100);//ok
            probMteCMGInv = (double[][]) lecEscHojCalc.leerHojaExcel("ProbMteCMG", 18, 4, 96, 1);//ok
            probMteCMGActDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("ProbMteCMG", 3, 5, 111);//ok
            probMteCMGActTitCeVe = (double[]) lecEscHojCalc.leerVectorHojaExcel("ProbMteCMG", 3, 3, 111);//ok
            tasasMejoraDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 3, 111);//ok
            tasasMejoraTitulares = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 2, 111);//ok
            tasasDesercion = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 4, 111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("DistViudas", 2, 2, 96, 96);//esta transpuesta   ok
            distOrfandad = (double[][]) lecEscHojCalc.leerHojaExcel("DistHuerfanos", 2, 2, 96, 111);//esta transpuesta   ok
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("DistAscendientes", 2, 2, 96, 96);//esta transpuesta   ok
            salariosHistoricos = (double[][]) lecEscHojCalc.leerHojaExcel("SalariosHistoricosIV", 4, 2, 75, 10); //ok
            incrementoRealSalarios = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4, 2,100);//ok
            inflacionAnual = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4, 4,100);//ok
            incRealSalMin = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4, 3,100);//ok
            art167LSS = (double[][]) lecEscHojCalc.leerHojaExcel("Art167LSS", 6, 2,22,3);//ok
            saldoRCVL73 = (double[][]) lecEscHojCalc.leerHojaExcel("RCV", 2, 2,51,75);//ok
            saldoCSL73 = (double[][]) lecEscHojCalc.leerHojaExcel("CS", 2, 2,51,75);//ok
            saldoVivL73 = (double[][]) lecEscHojCalc.leerHojaExcel("Vivienda", 2, 2,51,75);//ok
            salarioReal = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4, 13,75);//ok
            rangoSalariosCuotaSocial = (double[]) lecEscHojCalc.leerVectorHojaExcel("rangoSalarioCS", 3,3,6);//ok
            tasaBimestralRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,5,100);//ok
            tasaBimestralVivienda = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,6,100);//ok
            tasaAnualRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,10,100);//ok
            tasaAnualVivienda =  (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,11,100);//ok
            comisionSobreSaldo = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,7,100);//ok
            capitalizacionAportRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,8,100);//ok
            capitalizacionAportViv = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 4,9,100);//ok


        }else{

            asegbase = (double[][]) lecEscHojCalc.leerHojaExcel("PoblacionAsegBaseIV", 56, 2, 51, 75);//xxxxxx
            densidadCotizacion = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 108, 2, 75);//xxxxx
            probSobrevivenciaAseg = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemIV", 108, 3, 75, 3);//xxxxxxx
            //probabilidad Entrada pension 0 = invalidez, 1 = ceve , 2 = mte enf genral
            probEntradaPension = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemIV", 108, 6, 75, 3); //xxxxx
            ERdef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 108, 11, 100);//ok
            ERTemp73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 108, 12, 100);//ok
            ERTemDef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 108, 13, 100);//ok
            ERMte73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 108, 14, 100);//ok
            ERCeve73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemIV", 108, 15, 100);//ok
            probMteCMGInv = (double[][]) lecEscHojCalc.leerHojaExcel("ProbMteCMG", 18, 2, 96, 1);//ok
            probMteCMGActDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("ProbMteCMG", 3, 3, 111);//ok
            probMteCMGActTitCeVe = (double[]) lecEscHojCalc.leerVectorHojaExcel("ProbMteCMG", 3, 5, 111);//ok
            tasasMejoraDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 2, 111);//ok
            tasasMejoraTitulares = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 3, 111);//ok
            tasasDesercion = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 4, 111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("DistViudas", 101, 2, 96, 96);//esta transpuesta   ok
            distOrfandad = (double[][]) lecEscHojCalc.leerHojaExcel("DistHuerfanos", 101, 2, 96, 111);//esta transpuesta   ok
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("DistAscendientes", 101, 2, 96, 96);//esta transpuesta   ok
            salariosHistoricos = (double[][]) lecEscHojCalc.leerHojaExcel("SalariosHistoricosIV", 85, 2, 75, 10); //ok
            incrementoRealSalarios = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109, 2,100);//ok
            inflacionAnual = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109, 4,100);//ok
            incRealSalMin = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109, 3,100);//ok
            art167LSS = (double[][]) lecEscHojCalc.leerHojaExcel("Art167LSS", 6, 2,22,3);//ok            
            saldoRCVL73 = (double[][]) lecEscHojCalc.leerHojaExcel("RCV", 57, 2,51,75);//ok
            saldoCSL73 = (double[][]) lecEscHojCalc.leerHojaExcel("CS", 57, 2,51,75);//ok
            saldoVivL73 = (double[][]) lecEscHojCalc.leerHojaExcel("Vivienda", 57, 2,51,75);//ok
            rangoSalariosCuotaSocial = (double[]) lecEscHojCalc.leerVectorHojaExcel("rangoSalarioCS", 3,3,6);//ok          
            salarioReal = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109, 13,75);//ok
            tasaBimestralRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,5,100);//ok
            tasaBimestralVivienda = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,6,100);//ok
            tasaAnualRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,10,100);//ok
            tasaAnualVivienda =  (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,11,100);//ok
            comisionSobreSaldo = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,7,100);//ok
            capitalizacionAportRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,8,100);//ok
            capitalizacionAportViv = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinIV", 109,9,100);//ok
            
        }

        /******************************************************************
         * Proyectamos los salarios a utilizar en cada año de proyección. *
         ******************************************************************/
         pf.obtenerSalarios(salariosHistoricos,
                           incrementoRealSalarios,
                           incRealSalMin,
                           inflacionAnual,
                           salarioReal);
                
         /****************************************************************************
         * Proyectamos los salarios de cuota social que vamos a utilizar en cada año *
         *****************************************************************************/

         ci.obtenerSalariosProyeccionCuotaSocial(pf.getProySalariosReales(),
                                                 rangoSalariosCuotaSocial,
                                                 pf.getSalariosReales());
        
                /****************************************************************************
                 ****************************************************************************
                 *        Inicia el proceso de la proyección demografica y financiera.      *
                 ****************************************************************************
                 *****************************************************************************/

        for(int i=0;i<Constantes.ANIOS_PROYECCION-1;i++){           
            /**************************************************************************************
             * Proyectamos las probabilidades de activos y huerfanos para cada año de proyección. *
             **************************************************************************************/            
            pa.obtenerProbActivosyHuerfanos((i==0?probMteCMGActDerivadas:pa.getProbActivosMte()[0]),
                                            tasasMejoraDerivadas,
                                            tasasDesercion,
                                            false);//indicamos que no es CeVe            
            
            /*******************************************************************
             * Proyectamos a los asegurados vigentes en cada año de proyección *
             *******************************************************************/
            
            pa.obtenerAseguradosVigentesCadaAnio((i==0?asegbase:pa.getAseguradosVigentes()),
                                                       probSobrevivenciaAseg,
                                                       densidadCotizacion);
            
            /***********************************************
             * Proyectamos los saldos en cuenta individual *
             ***********************************************/
            
            ci.proyectarSaldosCuentaIndividual(pa.getAseguradosVigentes(),
                                               pa.getAseguradosCotizan(),
                                               pa.getAseguradosNoCotizan(),
                                               (i==0?saldoRCVL73:ci.getRcvProyectada()),
                                               (i==0?saldoCSL73:ci.getCsProyectada()),
                                               (i==0?saldoVivL73:ci.getVivProyectada()),
                                               probSobrevivenciaAseg,
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               comisionSobreSaldo[i]);
          
            /*********************************************************************************
             * Proyectamos los asegurados y pensionados de invalidez vigentes en cada año.   *
             *********************************************************************************/
            pa.obtenerProyeccionPensionados((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probMteCMGInv,
                                              probEntradaPension[0],
                                              densidadCotizacion,
                                              ERdef73[i],
                                              i,
                                              seguro,
                                              "inv");

            resumenInvalidez[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenInvalidez[i][1] = pa.getTotalPensionadosVigentesInv()[i] + fm.sumaVector(pa.getPensionadosFinalAnio()[0]);

            resumenInvalidez[i][6] = pa.getTotalPensionesViudezVigentesInv()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenInvalidez[i][7] = pa.getTotalPensionesOrfandadVigentesInv()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenInvalidez[i][8] = pa.getTotalPensionesAscendenciaVigentesInv()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);
    

            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/
            
            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               0,//no mando porcVal
                               "inv",
                               seguro);

            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitulares(pa.getPensionadosFinalAnio(),
                                                pa.getPensionadosFallecidos(), 
                                                pf.getCuantiaPromPensionados(),
                                                i,
                                                "inv",
                                                seguro);

            resumenInvalidez[i][2] = pf.getVolumenPensionTitularesInv()[i];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',
                                                "inv",
                                                seguro);
            
            resumenInvalidez[i][9] = pf.getVolumenPensionViudasInv()[i];
            
            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',
                                                "inv",
                                                seguro);

            resumenInvalidez[i][10] = pf.getVolumenPensionHuerfanosInv()[i];

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/
            
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',
                                                "inv",
                                                seguro);

            resumenInvalidez[i][11] = pf.getVolumenPensionAscendientesInv()[i];
            
            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);

            resumenInvalidez[i][3] = fm.sumaVector(ci.getSaldoPromRCVPensionados());            

            resumenInvalidez[i][4] = fm.sumaVector(ci.getSaldoPromCSPensionados());            

            resumenInvalidez[i][5] = fm.sumaVector(ci.getSaldoPromVivPensionados());

            /*******************************************************************************
             *       Proyeccion de los pensionados de Cesantía en edad avanzada y vejez.   *        /**CEVEEEEEEEEEE
             *******************************************************************************/

            /***********************************************************************
             * Proyectamos las probabilidades de muerte para pensionados de CeVe.  *
             ***********************************************************************/
            pa.obtenerProbActivosyHuerfanos((i==0?probMteCMGActTitCeVe:pa.getProbActivosMteCeVe()[0]),
                                            tasasMejoraTitulares,
                                            tasasDesercion,
                                            true);//indicamos que es CeVe

            /********************************************************************
             * Proyectamos los asegurados y pensionados vigentes en cada año.   *
             ********************************************************************/
            pa.obtenerProyeccionPensionados((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              pa.getProbActivosMteCeVe(),
                                              probEntradaPension[1],//Prob penion por CeVe
                                              densidadCotizacion,
                                              ERCeve73[i],
                                              i,
                                              seguro,
                                              "ceve");

            resumenCeVe[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenCeVe[i][1] = pa.getTotalPensionadosVigentesCeve()[i] + fm.sumaVector(pa.getPensionadosFinalAnio()[0]);

            resumenCeVe[i][6] = pa.getTotalPensionesViudezVigentesCeve()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenCeVe[i][7] = pa.getTotalPensionesOrfandadVigentesCeve()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenCeVe[i][8] = pa.getTotalPensionesAscendenciaVigentesCeve()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);

            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               0,//no mando porcVal
                               "ceve",
                               seguro);
            
            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitulares(pa.getPensionadosFinalAnio(),
                                                pa.getPensionadosFallecidos(),
                                                pf.getCuantiaPromPensionados(),
                                                i,
                                                "ceve",
                                                seguro);


            resumenCeVe[i][2] = pf.getVolumenPensionTitularesCeve()[i];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',
                                                "ceve",
                                                seguro);

            resumenCeVe[i][9] = pf.getVolumenPensionViudasCeve()[i];

            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',
                                                "ceve",
                                                seguro);

            resumenCeVe[i][10] = pf.getVolumenPensionHuerfanosCeve()[i];

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',
                                                "ceve",
                                                seguro);

            resumenCeVe[i][11] = pf.getVolumenPensionAscendientesCeve()[i];

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);

            resumenCeVe[i][3] = fm.sumaVector(ci.getSaldoPromRCVPensionados());

            resumenCeVe[i][4] = fm.sumaVector(ci.getSaldoPromCSPensionados());

            resumenCeVe[i][5] = fm.sumaVector(ci.getSaldoPromVivPensionados());


            /*******************************************************************
             * Proyección de los pensionados de muerte por enfermedad general  *              
             *******************************************************************/

            /********************************************************************
             * Proyectamos los asegurados y pensionados vigentes en cada año.   *
             ********************************************************************/
            pa.obtenerProyeccionPensionadosMte((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probEntradaPension[2],//Prob de entrada a pensión por mte
                                              densidadCotizacion,
                                              ERMte73[i],
                                              i,
                                              "mte");


            resumenMte[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenMte[i][4] = pa.getTotalPensionesViudezVigentesMte()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenMte[i][5] = pa.getTotalPensionesOrfandadVigentesMte()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenMte[i][6] = pa.getTotalPensionesAscendenciaVigentesMte()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);


            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               0,//no mando porcVal
                               "inv",
                               seguro);

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getNuevasViudasCadaAnio(),//Solo para obtener longitud
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',//viudas
                                                "mte",
                                                seguro);

            resumenMte[i][7] = pf.getVolumenPensionViudasMte()[i];

            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getNuevasViudasCadaAnio(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',//huerfanos
                                                "mte",
                                                seguro);

            resumenMte[i][8] = pf.getVolumenPensionHuerfanosMte()[i];

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getNuevasViudasCadaAnio(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',//ascendientes
                                                "mte",
                                                seguro);

            resumenMte[i][9] = pf.getVolumenPensionAscendientesMte()[i];

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);

            resumenMte[i][1] = fm.sumaVector(ci.getSaldoPromRCVPensionados());

            resumenMte[i][2] = fm.sumaVector(ci.getSaldoPromCSPensionados());

            resumenMte[i][3] = fm.sumaVector(ci.getSaldoPromVivPensionados());


            /*************************************************************************************
             * INICIA LA PROYECCIÓN DE LOS PENSIONADOS TEMPORALES EN CADA AÑO DE PROYECCIÓN.     *
             *************************************************************************************/

            /*********************************************************************************
             * Proyectamos los asegurados y pensionados de invalidez temporales en cada año. *
             *********************************************************************************/
            pa.obtenerProyeccionPensionadosTemporales((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probMteCMGInv,
                                              probEntradaPension[0],//Invalidez
                                              densidadCotizacion,
                                              ERMte73,
                                              ERTemp73[i],
                                              ERTemDef73[i],
                                              i,
                                              seguro,
                                              "inv");
            
            resumenInvalidez[i][12] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenInvalidez[i][13] = fm.sumaVector(pa.getPensionadosTempFinalAnio()[0]);

            resumenInvalidez[i][14] = pa.getPensionadosSobAnioCompInvTemp()[i];

            resumenInvalidez[i][15] = pa.getPensionadosTemDefInvTemp()[i];

            resumenInvalidez[i][16] = pa.getPensionadosTemDefFinaAnioInvTemp()[i];            
            
            resumenInvalidez[i][21] = pa.getTotalPensionesViudezVigentesInvTemp()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenInvalidez[i][22] = pa.getTotalPensionesOrfandadVigentesInvTemp()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenInvalidez[i][23] = pa.getTotalPensionesAscendenciaVigentesInvTemp()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);                      


            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               0,//no mando porcVal
                               "inv",
                               seguro);


            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitularesTemporales(pa.getPensionadosTempFinalAnio(),
                                                          pa.getPensionadosTempFallecidos(),
                                                          pf.getCuantiaPromPensionados(),
                                                          i,
                                                          "inv",
                                                          seguro);



            resumenInvalidez[i][17] = pf.getVolPenFinAnio();

            resumenInvalidez[(i+1<resumenInvalidez.length?i+1:resumenInvalidez.length-1)][18] = pf.getVolPenTempSobaniocompleto();

            resumenInvalidez[(i+2<resumenInvalidez.length?i+2:resumenInvalidez.length-1)][19] = pf.getVolPensTemDefMitadAnio();                        

            resumenInvalidez[(i+3<resumenInvalidez.length?i+3:resumenInvalidez.length-1)][20] = pf.getVolPensTemDefFinalAnio()+ pf.getVolumenPensTemDefFinalAnio()[(i+3<pf.getVolumenPensTemDefFinalAnio().length?i+3:pf.getVolumenPensTemDefFinalAnio().length-1)];
        



            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distViudas,
                                                    pa.getViudasSobrevivenCadaAnio(),
                                                    pa.getViudasSobrevivenFinalAnio(),
                                                    pa.getNuevasviudasFallecenMitadAnio(),
                                                    pa.getViudasFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCtiaPromViudasDecimoCuarto(),
                                                    i,
                                                    'v',
                                                    "inv",
                                                    seguro);

            resumenInvalidez[i][24] = pf.getVolumenPensionViudasInvTemp()[i];
                        
            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distOrfandad,
                                                    pa.getHuerfanosSobrevivenCadaAnio(),
                                                    pa.getHuerfanosSobrevivenFinalAnio(),
                                                    pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                    pa.getHuerfanosFallecenCadaAnio(),
                                                    pa.getProbHuefanos(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'h',
                                                    "inv",
                                                    seguro);

            resumenInvalidez[i][25] = pf.getVolumenPensionHuerfanosInvTemp()[i];
        
            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distAscendientes,
                                                    pa.getAscendientesSobrevivenCadaAnio(),
                                                    pa.getAscendientesSobrevivenFinalAnio(),
                                                    pa.getNuevosAscendientesFallecenMitadAnio(),
                                                    pa.getAscendientesFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'a',
                                                    "inv",
                                                    seguro);

            resumenInvalidez[i][26] = pf.getVolumenPensionAscendientesInvTemp()[i];           

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionadosTemp((i==0?asegbase:asegVig),
                                                     pa.getAseguradosCotizan(),
                                                     pa.getPensionadosMitadAnio(),
                                                     pa.getPensionadosTempFinalAnio(),
                                                     (i==0?saldoRCVL73:proyRCV),
                                                     (i==0?saldoCSL73:proyCS),
                                                     (i==0?saldoVivL73:proyViv),
                                                     distViudas,
                                                     distOrfandad,
                                                     distAscendientes,
                                                     pa.getNuevasViudasCadaAnio(),
                                                     pa.getNuevosHuerfanosCadaAnio(),
                                                     pa.getNuevosAscendientesCadaAnio(),
                                                     pf.getProySalariosReales()[i],
                                                     ci.getSalariosCSproy()[i],
                                                     tasaBimestralRCVyCS,
                                                     tasaBimestralVivienda,
                                                     tasaAnualRCVyCS,
                                                     tasaAnualVivienda,
                                                     comisionSobreSaldo,
                                                     capitalizacionAportRCVyCS[i],
                                                     capitalizacionAportViv[i],
                                                     i,
                                                     "inv");

            resumenInvalidez[i][27] = ci.getSaldoCITempRCV()[i];

            resumenInvalidez[i][28] = ci.getSaldoCITempCS()[i];

            resumenInvalidez[i][29] = ci.getSaldoCITempViv()[i];
            
            resumenInvalidez[i][30] = ci.getSaldoCITempDefRCV()[i];
            
            resumenInvalidez[i][31] = ci.getSaldoCITempDefCS()[i];
            
            resumenInvalidez[i][32] = ci.getSaldoCITempDefViv()[i];           

            //guardan variables a utilizar el siguiente año
            asegVig = pa.getAseguradosVigentes();
            proyRCV = ci.getRcvProyectada();
            proyCS = ci.getCsProyectada();
            proyViv = ci.getVivProyectada();
            
        }

         if(!latxt.existeArchivo(directorioSalida,archivoSalida+".ods")){
             lecEscHojCalc.crearArchivoExcel(directorioFormato, archivoFormato,".xls");
             lecEscHojCalc.guardarLibroOpenOffice(directorioSalida, archivoSalida);
         }         

        System.out.println("Guardando los resultados de la proyeccion IV");
        
        lecEscHojCalc.crearArchivoExcel(directorioSalida,archivoSalida, ".ods");
        lecEscHojCalc.crearHojaExcel("Invalidez_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenInvalidez, 5, 2, "##.#####");
        lecEscHojCalc.crearHojaExcel("Ceve_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenCeVe, 5, 2, "##.#####");
        lecEscHojCalc.crearHojaExcel("Muerte_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenMte, 5, 2, "##.#####");
        lecEscHojCalc.guardarLibroOpenOffice(directorioSalida,archivoSalida);



    }
   
}
