/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SIV;

/**
 *
 * @author antonio.alcalde
 */
import ProyeccionPensionados.Constantes;
import Librerias.*;
import Stock.ProyeccionDemograficaStock;
import Stock.ProyeccionFinancieraStock;

public class ProyeccionStockSIV {

    public void obtenerStockSIV(char sexo,String seguro){

        double[][] costosUnitRedimTit;
        double[][] costosUnitRedimEsp;        
        double[][] distViudas;
        double[][] distHuerfanos;
        double[][] distAscendientes;
        double[][] probSobViudas;
        double[][] probSobHuerfanos;
        double[][] probSobAscendientes;        
        double[]   casosInvalidez;
        double[]   casosCeVe;        
        double[]   casosViudez;
        double[]   casosOrfandad;
        double[]   casosAscendientes;
        double[]   probMteInvalidos;
        double[][] probSobCeVe;
        double[]   costosUnitariosTit;
        double[]   costosUnitariosEsp;
        double[]   costosUnitariosDer;
        double[]   cuantiaInvalidez;
        double[]   cuantiaCeVe;
        double[]   cuantiaViudez;
        double[]   cuantiaOrfandad;
        double[]   cuantiaAscendencia;        
        double[]   volumenPensionTitulares = new double[Constantes.ANIOS_PROYECCION-1];
        double[]   volumenPensionTitularesCeVe = new double[Constantes.ANIOS_PROYECCION-1];

        double[][] resumenIVGMP = new double[Constantes.ANIOS_PROYECCION-1][8];
        double[][] resumenIVDemFin = new double[Constantes.ANIOS_PROYECCION-1][16];


        /************************************************************************
         *    Se crean los objetos que se requieren en la proyeccion del SIV    *
         ************************************************************************/
        LecturaEscrituraHojasCalculo lecEscHojCalc = new LecturaEscrituraHojasCalculo();
        FuncionesMatematicas fm = new FuncionesMatematicas();
        ProyeccionDemograficaStock proyDem = new ProyeccionDemograficaStock();
        ProyeccionFinancieraStock proyFin = new ProyeccionFinancieraStock();
        LecturaArchivoTxt latxt = new LecturaArchivoTxt();      

        /***************************************************************************************************
         *   Direccion en la que se encuentran los archivos, que el programa va tomar para procesarlos.     *
         ****************************************************************************************************/
        String directorioArchivoEntradas = Constantes.DIRECTORIO_DATOS_ENTRADA;
        String directorioFormato = Constantes.DIRECTORIO_FORMATO;
        String directorioSalida = Constantes.DIRECTORIO_SALIDA;
        String archivoEntradas = Constantes.NOMBRE_ARCHIVO_ENTRADA;
        String archivoSalida = Constantes.NOMBRE_ARCHIVO_SALIDA_IV;
        String archivoFormato = Constantes.NOMBRE_ARCHIVO_FORMATO_IV;

        /*************************************************************************
         *Obtención de parametros de entrada del SIV para realizar la proyección *
         *************************************************************************/

        lecEscHojCalc.abrirArchivoExcel(directorioArchivoEntradas,archivoEntradas,".xls");

        if(sexo == Constantes.HOMBRE){

            casosInvalidez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 4,3,96);//ok
            casosCeVe = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 4,7,96);//ok
            casosViudez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 105,4,96);//ok
            casosOrfandad = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 105,5,96);//ok
            casosAscendientes = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 105,6,96);//ok
            probMteInvalidos = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockBiometricas", 4,3,96);//ok
            probSobCeVe =  (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 2, 100, 96);
            costosUnitariosTit = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,3,111);//ok
            costosUnitariosEsp = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,4,111);//ok
            costosUnitariosDer = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,5,111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 4, 2, 96, 96);
            distHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 4, 2, 96, 96);
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 4, 2, 96, 96);
            probSobViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 101, 100, 96);
            probSobHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 106, 101, 100, 96);
            probSobAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 106, 101, 100, 96);
            cuantiaInvalidez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,8,96);//ok
            cuantiaCeVe = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,12,96);//ok
            cuantiaViudez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,9,96);//ok
            cuantiaOrfandad = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,10,96);//ok
            cuantiaAscendencia = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,11,96);//ok
            
        }else{

            casosInvalidez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 105,3,96);//ok
            casosCeVe = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 105,7,96);//ok
            casosViudez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 4,4,96);//ok
            casosOrfandad = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 4,5,96);//ok
            casosAscendientes = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemIV", 4,6,96);//ok
            probMteInvalidos = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockBiometricas", 4,4,96);//ok
            probSobCeVe =  (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 2, 100, 96);
            costosUnitariosTit = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,3,111);//ok
            costosUnitariosEsp = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,4,111);//ok
            costosUnitariosDer = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,5,111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 2, 96, 96);
            distHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 106, 2, 96, 96);
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 106, 2, 96, 96);
            probSobViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 2, 100, 96);
            probSobHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 106, 2, 100, 96);
            probSobAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 106, 2, 100, 96);
            cuantiaInvalidez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,8,96);//ok
            cuantiaCeVe = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 106,12,96);//ok
            cuantiaViudez = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,9,96);//ok
            cuantiaOrfandad = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,10,96);//ok
            cuantiaAscendencia = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasIV", 4,11,96);//ok
            
        }
        
            /*********************************************************************
             *Proyeccion del Stock de pensionados del Seguro de Invalidez y VIda *
             *********************************************************************/

        /*****************************************
         *  Stock de pensionados por Invalidez   *
         *****************************************/

        System.out.println("Inicia proyeccion del Stock del SIV");

        proyDem.obtenerPensionadosSobrevivientes(casosInvalidez,
                                                 probMteInvalidos);        

        resumenIVDemFin[0] = fm.sumaMatriz(proyDem.getPensionadosSobrevivientes());//resumenDemografico


        proyDem.obtenerPensionadosFallecidos(proyDem.getPensionadosSobrevivientes(),
                                             probMteInvalidos);
        
        //Costos Unitarios titulares
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);
        
        costosUnitRedimTit = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);       

        //Obtenemos las GMP de los pensionados
        for(int año=0;año<resumenIVGMP.length;año++){
            resumenIVGMP[año][0] = (fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosSobrevivientes()[año]) +
                                  fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosFallecidos()[año])/2D)/1000000D;
        }

   
        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosEsp,
                                       Constantes.PORC_COSTO_UNITARIO);
        
        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);               
        //Nuevas Viudas
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distViudas);

        //VIudas Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobViudas));


        //Obtenemos las viudas sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobViudas));
               

        //Obtenemos el Stock de las viudas sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobViudas),
                                         casosViudez,
                                         false);//No es CeVe
        
        /*******************************************************************************************
         *                              Obtenemos la GMP de las viudas *
         *******************************************************************************************/       

        for(int año=0;año<resumenIVGMP.length;año++){                  //***este
            resumenIVGMP[año][1] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                    (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])/2D) +
                                    (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }
       
        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenIVDemFin[1] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        
        proyFin.obtenerCuantiaPensionados(cuantiaInvalidez);
        
        
                               /**Obtenemos el volumen de pensiones de invalidez*/
        //Primer año
        volumenPensionTitulares[0] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[0], proyFin.getCuantiaPensionados()[0]) * 12)/1000000D;
        
        //demas años
        for(int año=1;año<volumenPensionTitulares.length;año++){
            volumenPensionTitulares[año] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[año], proyFin.getCuantiaPensionados()[año]) * 12)/1000000D +
                                           (fm.sumaProducto(proyDem.getPensionadosFallecidos()[año], proyFin.getCuantiaPensionados()[año]) * 6)/1000000D;            
        }


        resumenIVDemFin[4] = volumenPensionTitulares;//Resumen financiero


        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     true,//si es viuda
                                                     true);// si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distViudas);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaViudez);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenIVDemFin[5] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero
        
        
        
        /**********************************************************************
         *              Proyeccion de los huefanos de Invalidez               *
         **********************************************************************/

        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosDer,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    0);        
        //Nuevos huefanos
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distHuerfanos);       
        
        //huefanos Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobHuerfanos));         
        
        //Obtenemos los huefanos sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobHuerfanos));

        //double aux = fm.sumaVector(fm.sumaMatriz(proyDem.getDerivadasSobSinNuevas()));

        //Obtenemos el Stock de los huefanos sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobHuerfanos),
                                         casosOrfandad,
                                         false);//No es CeVe);

        /*******************************************************************************************
         *                              Obtenemos la GMP de los huerfanos                          *
         *******************************************************************************************/
        for(int año=0;año<resumenIVGMP.length;año++){
            resumenIVGMP[año][2] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;            
        }        

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());        

        resumenIVDemFin[2] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico
        
        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV      

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distHuerfanos);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaOrfandad);       

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenIVDemFin[6] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero

        


        /**********************************************************************
         *              Proyeccion de los ascendientes de Invalidez           *
         **********************************************************************/

        //Costos Unitarios ascendientes(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosDer,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevos ascendientes
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distAscendientes);

        //ascendientes Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobAscendientes));

        //Obtenemos los ascendientes sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobAscendientes));

        //Obtenemos el Stock de los ascendientes sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobAscendientes),
                                         casosAscendientes,
                                         false);//No es CeVe);

        /*******************************************************************************************
         *                              Obtenemos la GMP de los ascendientes                          *
         *******************************************************************************************/
        for(int año=0;año<resumenIVGMP.length;año++){
            resumenIVGMP[año][3] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }
        
        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenIVDemFin[3] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distAscendientes);


        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaAscendencia);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenIVDemFin[7] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero



        /****************************************************************************
         *          Proyeccion de Cesantía en edad avanzada y vejez.                *   :) :) :)
         ****************************************************************************/


        /*****************************************
         *  Stock de pensionados por CeVe        *
         *****************************************/

        proyDem.obtenerPensionadosSobrevivientes(fm.transponer(probSobCeVe),
                                                 casosCeVe);
                

        resumenIVDemFin[8] = fm.sumaMatriz(proyDem.getPensionadosSobrevivientes());//resumenDemografico

        
        proyDem.obtenerPensionadosFallecidos(proyDem.getPensionadosSobrevivientes(),
                                             fm.transponer(probSobCeVe));

        //Costos Unitarios titulares
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimTit = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);

        //Obtenemos las GMP de los pensionados
        for(int año=0;año<resumenIVGMP.length;año++){
            resumenIVGMP[año][4] = (fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosSobrevivientes()[año]) +
                                  fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosFallecidos()[año])/2D)/1000000D;
        }        

        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosEsp,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevas Viudas
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distViudas);        

        //VIudas Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobViudas));

        
        //Obtenemos las viudas sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobViudas));
        
        //Obtenemos el Stock de las viudas sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobViudas),
                                         casosViudez,
                                         true);//Es CeVe);

        

       
        /*******************************************************************************************
         *                              Obtenemos la GMP de las viudas *
         *******************************************************************************************/

        for(int año=0;año<resumenIVGMP.length;año++){                  //***este
            resumenIVGMP[año][5] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenIVDemFin[9] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico


        proyFin.obtenerCuantiaPensionados(cuantiaCeVe);


                               /**Obtenemos el volumen de pensiones de CeVe*/
        //Primer año
        volumenPensionTitularesCeVe[0] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[0], proyFin.getCuantiaPensionados()[0]) * 12)/1000000D;

        //demas años
        for(int año=1;año<volumenPensionTitularesCeVe.length;año++){
            volumenPensionTitularesCeVe[año] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[año], proyFin.getCuantiaPensionados()[año]) * 12)/1000000D +
                                           (fm.sumaProducto(proyDem.getPensionadosFallecidos()[año], proyFin.getCuantiaPensionados()[año]) * 6)/1000000D;
        }


        resumenIVDemFin[12] = volumenPensionTitularesCeVe;//Resumen financiero


        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     true,//si es viuda
                                                     true);// si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distViudas);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaViudez);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenIVDemFin[13] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero



        /**********************************************************************
         *              Proyeccion de los huefanos de CeVe                    *
         **********************************************************************/
                
        //Costos Unitarios titulares
        proyFin.obtenerCostosUnitarios(costosUnitariosDer,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    0);
        //Nuevos huefanos
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distHuerfanos);
        
        //huefanos Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobHuerfanos));               

        //Obtenemos los huefanos sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobHuerfanos));

        //Obtenemos el Stock de los huefanos sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobHuerfanos),
                                         casosOrfandad,
                                         true);//Es CeVe););

        /*******************************************************************************************
         *                              Obtenemos la GMP de los huerfanos                          *
         *******************************************************************************************/
        for(int año=0;año<resumenIVGMP.length;año++){
            resumenIVGMP[año][6] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
           
        }

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenIVDemFin[10] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distHuerfanos);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaOrfandad);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenIVDemFin[14] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero




        /**********************************************************************
         *              Proyeccion de los ascendientes de CeVe           *
         **********************************************************************/

        //Costos Unitarios ascendientes(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosDer,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevos ascendientes
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distAscendientes);       

        //ascendientes Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobAscendientes));         

        //Obtenemos los ascendientes sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobAscendientes));

        //Obtenemos el Stock de los ascendientes sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobAscendientes),
                                         casosAscendientes,
                                         true);//Es CeVe);

        /*******************************************************************************************
         *                              Obtenemos la GMP de los ascendientes                          *
         *******************************************************************************************/
        for(int año=0;año<resumenIVGMP.length;año++){
            resumenIVGMP[año][7] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }        

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenIVDemFin[11] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distAscendientes);


        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaAscendencia);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenIVDemFin[15] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero

        if(!latxt.existeArchivo(directorioSalida,archivoSalida+".ods")){
             lecEscHojCalc.crearArchivoExcel(directorioFormato, archivoFormato,".xls");
             lecEscHojCalc.guardarLibroOpenOffice(directorioSalida, archivoSalida);
         }

        System.out.println("Guardando los resultados de la proyeccion IV");

        lecEscHojCalc.crearArchivoExcel(directorioSalida,archivoSalida, ".ods");
        lecEscHojCalc.crearHojaExcel("Stock_"+sexo);
        lecEscHojCalc.escribirHojasExcel(fm.transponer(resumenIVDemFin), 5, 2, "##.#####");
        lecEscHojCalc.crearHojaExcel("Stock_GMP_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenIVGMP, 5, 2, "##.#####");
        lecEscHojCalc.guardarLibroOpenOffice(directorioSalida,archivoSalida);

    }



}
