/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package SRT;

/**
 *
 * @author Antonio-Alcalde
 */
import ProyeccionPensionados.CuentaIndividual;
import ProyeccionPensionados.ProyeccionDemografica;
import ProyeccionPensionados.ProyeccionFinanciera;
import ProyeccionPensionados.Constantes;
import Librerias.*;


public class ProyeccionSRT {

    public void obtenerFuturosPensionadosSRT(char sexo,String seguro) {

        /***********************************
         * Lo que estoy metiendo
         ************************************/
        double[][] asegbase;
        double[][] probSobrevivenciaAseg;
        double[][] probEntradaPension;
        double[][] distViudas;
        double[][] distOrfandad;
        double[][] distAscendientes;
        double[][] salariosHistoricos;
        double[][] art167LSS;
        double[][] saldoRCVL73;
        double[][] saldoCSL73;
        double[][] saldoVivL73;        
        double[][] asegVig = null;        
        double[][] proyRCV = null;
        double[][] proyCS = null;
        double[][] proyViv = null;

        double[][] probMteCMGInv;
        double[] densidadCotizacion;
        double[] ERdef73;
        double[] ERTemp73;
        double[] ERTemDef73;
        double[] ERMte73;        
        double[] probMteCMGActDerivadas;        
        double[] tasasMejoraDerivadas;        
        double[] tasasDesercion;
        double[] incrementoRealSalarios;
        double[] inflacionAnual;
        double[] incRealSalMin;
        double[] salarioReal;
        double[] rangoSalariosCuotaSocial;
        double[] comisionSobreSaldo;
        double[] tasaBimestralRCVyCS;
        double[] tasaBimestralVivienda;
        double[] tasaAnualRCVyCS;
        double[] tasaAnualVivienda;
        double[] capitalizacionAportRCVyCS;
        double[] capitalizacionAportViv;


        double[][] resumenIP100 = new double[Constantes.ANIOS_PROYECCION-1][33];
        double[][] resumenIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1][33];
        double[][] resumenIPMenor50 = new double[Constantes.ANIOS_PROYECCION-1][33];
        double[][] resumenMte = new double[Constantes.ANIOS_PROYECCION-1][10];

        /***************************************************************************************************
         *   Direccion en la que se encuentran los archivos, que el programa va tomar para procesarlos.     *
         ****************************************************************************************************/
        String directorioArchivoEntradas = Constantes.DIRECTORIO_DATOS_ENTRADA;
        String directorioFormato = Constantes.DIRECTORIO_FORMATO;
        String directorioSalida = Constantes.DIRECTORIO_SALIDA;
        String archivoEntradas = Constantes.NOMBRE_ARCHIVO_ENTRADA;
        String archivoSalida = Constantes.NOMBRE_ARCHIVO_SALIDA_RT;
        String archivoFormato = Constantes.NOMBRE_ARCHIVO_FORMATO_RT;
        
        /************************************************************************
         *    Se crean los objetos que se requieren en la proyeccion del SIV    *
         ************************************************************************/
        LecturaEscrituraHojasCalculo lecEscHojCalc = new LecturaEscrituraHojasCalculo();
        ProyeccionDemografica pa = new ProyeccionDemografica();
        ProyeccionFinanciera pf = new ProyeccionFinanciera();
        FuncionesMatematicas fm = new FuncionesMatematicas();
        CuentaIndividual ci = new CuentaIndividual();
        LecturaArchivoTxt latxt = new LecturaArchivoTxt();  

        /*************************************************************************
         *Obtención de parametros de entrada del SIV para realizar la proyección *
         *************************************************************************/

        lecEscHojCalc.abrirArchivoExcel(directorioArchivoEntradas,archivoEntradas,".xls");

        if(sexo == Constantes.HOMBRE){
            
            asegbase = (double[][]) lecEscHojCalc.leerHojaExcel("PoblacionAsegBaseRT", 2, 2, 51, 75);//ok
            densidadCotizacion = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 4, 2, 75);//ok
            probSobrevivenciaAseg = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemRT", 4, 3, 75, 3);//ok
            //probabilidad Entrada pension: 0 = IP=100%, 1 =IP MENOR 100% MAYOR 50%  , 2 =IP MENOR 50%, 3 = MTE RT
            probEntradaPension = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemRT", 4, 6, 75, 4);//ok
            ERdef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 4, 11, 100);//ok
            ERTemp73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 4, 12, 100);//ok
            ERTemDef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 4, 13, 100);//ok
            ERMte73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 4, 14, 100);//ok
            probMteCMGInv = (double[][]) lecEscHojCalc.leerHojaExcel("ProbMteCMG", 18, 4, 96, 1);//ok
            probMteCMGActDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("ProbMteCMG", 3, 5, 111);//ok
            tasasMejoraDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 3, 111);//ok
            tasasDesercion = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 4, 111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("DistViudas", 2, 2, 96, 96);//esta transpuesta   ok
            distOrfandad = (double[][]) lecEscHojCalc.leerHojaExcel("DistHuerfanos", 2, 2, 96, 111);//esta transpuesta   ok
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("DistAscendientes", 2, 2, 96, 96);//esta transpuesta   ok
            salariosHistoricos = (double[][]) lecEscHojCalc.leerHojaExcel("SalariosHistoricosIV", 4, 2, 75, 10); //ok
            incrementoRealSalarios = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4, 2,100);//ok
            inflacionAnual = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4, 4,100);//ok
            incRealSalMin = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4, 3,100);//ok
            art167LSS = (double[][]) lecEscHojCalc.leerHojaExcel("Art167LSS", 6, 2,22,3);//ok
            saldoRCVL73 = (double[][]) lecEscHojCalc.leerHojaExcel("RCV", 2, 2,51,75);//ok
            saldoCSL73 = (double[][]) lecEscHojCalc.leerHojaExcel("CS", 2, 2,51,75);//ok
            saldoVivL73 = (double[][]) lecEscHojCalc.leerHojaExcel("Vivienda", 2, 2,51,75);//ok
            salarioReal = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4, 13,75);//ok
            rangoSalariosCuotaSocial = (double[]) lecEscHojCalc.leerVectorHojaExcel("rangoSalarioCS", 3,3,6);//ok
            tasaBimestralRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,5,100);//ok
            tasaBimestralVivienda = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,6,100);//ok
            tasaAnualRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,10,100);//ok
            tasaAnualVivienda =  (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,11,100);//ok
            comisionSobreSaldo = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,7,100);//ok
            capitalizacionAportRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,8,100);//ok
            capitalizacionAportViv = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 4,9,100);//ok


        }else{

            asegbase = (double[][]) lecEscHojCalc.leerHojaExcel("PoblacionAsegBaseRT", 56, 2, 51, 75);//ok
            densidadCotizacion = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 108, 2, 75);//ok
            probSobrevivenciaAseg = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemRT", 108, 3, 75, 3);//ok
            //probabilidad Entrada pension: 0 = IP=100%, 1 =IP MENOR 100% MAYOR 50%  , 2 =IP MENOR 50%, 3 = MTE RT
            probEntradaPension = (double[][]) lecEscHojCalc.leerHojaExcel("HipDemRT", 108, 6, 75, 4);//ok
            ERdef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 108, 11, 100);//ok
            ERTemp73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 108, 12, 100);//ok
            ERTemDef73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 108, 13, 100);//ok
            ERMte73 = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipDemRT", 108, 14, 100);//ok
            probMteCMGInv = (double[][]) lecEscHojCalc.leerHojaExcel("ProbMteCMG", 18, 2, 96, 1);//ok
            probMteCMGActDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("ProbMteCMG", 3, 3, 111);//ok
            tasasMejoraDerivadas = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 2, 111);//ok
            tasasDesercion = (double[]) lecEscHojCalc.leerVectorHojaExcel("TasaMejorayDesercion", 4, 4, 111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("DistViudas", 101, 2, 96, 96);//esta transpuesta   ok
            distOrfandad = (double[][]) lecEscHojCalc.leerHojaExcel("DistHuerfanos", 101, 2, 96, 111);//esta transpuesta   ok
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("DistAscendientes", 101, 2, 96, 96);//esta transpuesta   ok
            salariosHistoricos = (double[][]) lecEscHojCalc.leerHojaExcel("SalariosHistoricosIV", 85, 2, 75, 10); //ok
            incrementoRealSalarios = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109, 2,100);//ok
            inflacionAnual = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109, 4,100);//ok
            incRealSalMin = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109, 3,100);//ok
            art167LSS = (double[][]) lecEscHojCalc.leerHojaExcel("Art167LSS", 6, 2,22,3);//ok
            saldoRCVL73 = (double[][]) lecEscHojCalc.leerHojaExcel("RCV", 57, 2,51,75);//ok
            saldoCSL73 = (double[][]) lecEscHojCalc.leerHojaExcel("CS", 57, 2,51,75);//ok
            saldoVivL73 = (double[][]) lecEscHojCalc.leerHojaExcel("Vivienda", 57, 2,51,75);//ok
            rangoSalariosCuotaSocial = (double[]) lecEscHojCalc.leerVectorHojaExcel("rangoSalarioCS", 3,3,6);//ok
            salarioReal = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109, 13,75);//ok
            tasaBimestralRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,5,100);//ok
            tasaBimestralVivienda = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,6,100);//ok
            tasaAnualRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,10,100);//ok
            tasaAnualVivienda =  (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,11,100);//ok
            comisionSobreSaldo = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,7,100);//ok
            capitalizacionAportRCVyCS = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,8,100);//ok
            capitalizacionAportViv = (double[]) lecEscHojCalc.leerVectorHojaExcel("HipFinRT", 109,9,100);//ok
                        
        }

        /******************************************************************
         * Proyectamos los salarios a utilizar en cada año de proyección. *
         ******************************************************************/
         pf.obtenerSalarios(salariosHistoricos,
                           incrementoRealSalarios,
                           incRealSalMin,
                           inflacionAnual,
                           salarioReal);

         
         /****************************************************************************
         * Proyectamos los salarios de cuota social que vamos a utilizar en cada año *
         *****************************************************************************/

         ci.obtenerSalariosProyeccionCuotaSocial(pf.getProySalariosReales(),
                                                 rangoSalariosCuotaSocial,
                                                 pf.getSalariosReales());
        
                /****************************************************************************
                 ****************************************************************************
                 *        Inicia el proceso de la proyección demografica y financiera.      *
                 ****************************************************************************
                 *****************************************************************************/

        for(int i=0;i<Constantes.ANIOS_PROYECCION-1;i++){            

            /**************************************************************************************
             * Proyectamos las probabilidades de activos y huerfanos para cada año de proyección. *
             **************************************************************************************/
            

            pa.obtenerProbActivosyHuerfanos((i==0?probMteCMGActDerivadas:pa.getProbActivosMte()[0]),
                                            tasasMejoraDerivadas,
                                            tasasDesercion,
                                            false);//indicamos que no es CeVe
            
            /*******************************************************************
             * Proyectamos a los asegurados vigentes en cada año de proyección *
             *******************************************************************/
            
            pa.obtenerAseguradosVigentesCadaAnio((i==0?asegbase:pa.getAseguradosVigentes()),
                                                       probSobrevivenciaAseg,
                                                       densidadCotizacion);
            
            /***********************************************
             * Proyectamos los saldos en cuenta individual *
             ***********************************************/
            
            ci.proyectarSaldosCuentaIndividual(pa.getAseguradosVigentes(),
                                               pa.getAseguradosCotizan(),
                                               pa.getAseguradosNoCotizan(),
                                               (i==0?saldoRCVL73:ci.getRcvProyectada()),
                                               (i==0?saldoCSL73:ci.getCsProyectada()),
                                               (i==0?saldoVivL73:ci.getVivProyectada()),
                                               probSobrevivenciaAseg,
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               comisionSobreSaldo[i]);
          

            /********************************************************************
             * Proyectamos los asegurados y pensionados vigentes en cada año.   *
             ********************************************************************/
            pa.obtenerProyeccionPensionados((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probMteCMGInv,
                                              probEntradaPension[0],
                                              densidadCotizacion,
                                              ERdef73[i],
                                              i,
                                              seguro,
                                              "ip100");


            resumenIP100[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenIP100[i][1] = pa.getTotalPensionadosVigentesIP100()[i] + fm.sumaVector(pa.getPensionadosFinalAnio()[0]);

            resumenIP100[i][6] = pa.getTotalPensionesViudezVigentesIP100()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenIP100[i][7] = pa.getTotalPensionesOrfandadVigentesIP100()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenIP100[i][8] = pa.getTotalPensionesAscendenciaVigentesIP100()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);
    

            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/
            
            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               (sexo=='H'?Constantes.PORC_VAL_IGUAL_100H:Constantes.PORC_VAL_IGUAL_100M),
                               "ip100",
                               seguro);//IV y RT se obtiene igual
          
            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitulares(pa.getPensionadosFinalAnio(),
                                                pa.getPensionadosFallecidos(), 
                                                pf.getCuantiaPromPensionados(),
                                                i,
                                                "ip100",
                                                seguro);

            resumenIP100[i][2] = pf.getVolumenPensionTitularesIP100()[i];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',
                                                "ip100",
                                                seguro);
            
            resumenIP100[i][9] = pf.getVolumenPensionViudasIP100()[i];
            
            /******************************************
             * Volumen de pensiones para huerfanos.   *
             ******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',
                                                "ip100",
                                                seguro);

            resumenIP100[i][10] = pf.getVolumenPensionHuerfanosIP100()[i];

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/
            
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',
                                                "ip100",
                                                seguro);

            resumenIP100[i][11] = pf.getVolumenPensionAscendientesIP100()[i];
            
            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);

            resumenIP100[i][3] = fm.sumaVector(ci.getSaldoPromRCVPensionados());

            resumenIP100[i][4] = fm.sumaVector(ci.getSaldoPromCSPensionados());

            resumenIP100[i][5] = fm.sumaVector(ci.getSaldoPromVivPensionados());

            
            /****************************************************************************************
             *  Proyección de los pensionados por incapacidad permanente menor 100% mayor 50%.      *
             ****************************************************************************************/

            /********************************************************************
             * Proyectamos los asegurados y pensionados vigentes en cada año.   *
             ********************************************************************/
            pa.obtenerProyeccionPensionados((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probMteCMGInv,
                                              probEntradaPension[1],//IP menor a 100
                                              densidadCotizacion,
                                              ERdef73[i],
                                              i,
                                              seguro,
                                              "ipMenor100");


            resumenIPMenor100[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenIPMenor100[i][1] = pa.getTotalPensionadosVigentesIPMenor100()[i] + fm.sumaVector(pa.getPensionadosFinalAnio()[0]);

            resumenIPMenor100[i][6] = pa.getTotalPensionesViudezVigentesIPMenor100()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenIPMenor100[i][7] = pa.getTotalPensionesOrfandadVigentesIPMenor100()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenIPMenor100[i][8] = pa.getTotalPensionesAscendenciaVigentesIPMenor100()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);


            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               (sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M),
                               "ipMenor100",
                               seguro);//IV y RT se obtiene igual

            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitulares(pa.getPensionadosFinalAnio(),
                                                pa.getPensionadosFallecidos(),
                                                pf.getCuantiaPromPensionados(),
                                                i,
                                                "ipMenor100",
                                                seguro);

            resumenIPMenor100[i][2] = pf.getVolumenPensionTitularesIPMenor100()[i];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',
                                                "ipMenor100",
                                                seguro);

            resumenIPMenor100[i][9] = pf.getVolumenPensionViudasIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);
            
            /******************************************
             * Volumen de pensiones para huerfanos.   *
             ******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',
                                                "ipMenor100",
                                                seguro);

            resumenIPMenor100[i][10] = pf.getVolumenPensionHuerfanosIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',
                                                "ipMenor100",
                                                seguro);

            resumenIPMenor100[i][11] = pf.getVolumenPensionAscendientesIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);            

            resumenIPMenor100[i][3] = fm.sumaVector(ci.getSaldoPromRCVPensionados())*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][4] = fm.sumaVector(ci.getSaldoPromCSPensionados())*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][5] = fm.sumaVector(ci.getSaldoPromVivPensionados())*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);



            /*********************************************************************
             *          Proyeccion de incapacidad permanente menor al 50%.        *
             *********************************************************************/

            /********************************************************************
             * Proyectamos los asegurados y pensionados vigentes en cada año.   *
             ********************************************************************/
            pa.obtenerProyeccionPensionados((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probMteCMGInv,
                                              probEntradaPension[2],//IP menor a 50
                                              densidadCotizacion,
                                              ERdef73[i],
                                              i,
                                              seguro,
                                              "ipMenor50");


            resumenIPMenor50[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenIPMenor50[i][1] = pa.getTotalPensionadosVigentesIPMenor50()[i] + fm.sumaVector(pa.getPensionadosFinalAnio()[0]);

            resumenIPMenor50[i][6] = pa.getTotalPensionesViudezVigentesIPMenor50()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenIPMenor50[i][7] = pa.getTotalPensionesOrfandadVigentesIPMenor50()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenIPMenor50[i][8] = pa.getTotalPensionesAscendenciaVigentesIPMenor50()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);


            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               (sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M),
                               "ipMenor50",
                               seguro);//IV y RT se obtiene igual

            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitulares(pa.getPensionadosFinalAnio(),
                                                pa.getPensionadosFallecidos(),
                                                pf.getCuantiaPromPensionados(),
                                                i,
                                                "ipMenor50",
                                                seguro);

            resumenIPMenor50[i][2] = pf.getVolumenPensionTitularesIPMenor50()[i];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',
                                                "ipMenor50",
                                                seguro);

            resumenIPMenor50[i][9] = pf.getVolumenPensionViudasIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            /******************************************
             * Volumen de pensiones para huerfanos.   *
             ******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',
                                                "ipMenor50",
                                                seguro);

            resumenIPMenor50[i][10] = pf.getVolumenPensionHuerfanosIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getPensionadosFallecidos(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',
                                                "ipMenor50",
                                                seguro);

            resumenIPMenor50[i][11] = pf.getVolumenPensionAscendientesIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);

            resumenIPMenor50[i][3] = fm.sumaVector(ci.getSaldoPromRCVPensionados())*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][4] = fm.sumaVector(ci.getSaldoPromCSPensionados())*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][5] = fm.sumaVector(ci.getSaldoPromVivPensionados())*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);


            /*******************************************************************
             * Proyección de los pensionados de muerte por enfermedad general  *               
             *******************************************************************/

            /********************************************************************
             * Proyectamos los asegurados y pensionados vigentes en cada año.   *
             ********************************************************************/
            pa.obtenerProyeccionPensionadosMte((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probEntradaPension[3],//Prob de entrada a pensión por mte por RT
                                              densidadCotizacion,
                                              ERMte73[i],
                                              i,
                                              "mte");


            resumenMte[i][0] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenMte[i][4] = pa.getTotalPensionesViudezVigentesMte()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenMte[i][5] = pa.getTotalPensionesOrfandadVigentesMte()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenMte[i][6] = pa.getTotalPensionesAscendenciaVigentesMte()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);


            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               0,//no mando porcVal
                               "mte",//inv
                               seguro);


            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getNuevasViudasCadaAnio(),//Solo para obtener longitud
                                                distViudas,
                                                pa.getViudasSobrevivenCadaAnio(),
                                                pa.getViudasSobrevivenFinalAnio(),
                                                pa.getNuevasviudasFallecenMitadAnio(),
                                                pa.getViudasFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCtiaPromViudasDecimoCuarto(),
                                                i,
                                                'v',//viudas
                                                "mte",
                                                seguro);

            resumenMte[i][7] = pf.getVolumenPensionViudasMteRT()[i];

            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getNuevasViudasCadaAnio(),
                                                distOrfandad,
                                                pa.getHuerfanosSobrevivenCadaAnio(),
                                                pa.getHuerfanosSobrevivenFinalAnio(),
                                                pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                pa.getHuerfanosFallecenCadaAnio(),
                                                pa.getProbHuefanos(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'h',//huerfanos
                                                "mte",
                                                seguro);

            resumenMte[i][8] = pf.getVolumenPensionHuerfanosMteRT()[i];

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadas(pa.getNuevasViudasCadaAnio(),
                                                distAscendientes,
                                                pa.getAscendientesSobrevivenCadaAnio(),
                                                pa.getAscendientesSobrevivenFinalAnio(),
                                                pa.getNuevosAscendientesFallecenMitadAnio(),
                                                pa.getAscendientesFallecenCadaAnio(),
                                                pa.getProbActivosMte(),
                                                pf.getCuantiaPromHuerfyAsc(),
                                                i,
                                                'a',//ascendientes
                                                "mte",
                                                seguro);

            resumenMte[i][9] = pf.getVolumenPensionAscendientesMteRT()[i];

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionados((i==0?asegbase:asegVig),
                                               pa.getAseguradosCotizan(),
                                               pa.getPensionadosMitadAnio(),
                                               (i==0?saldoRCVL73:proyRCV),
                                               (i==0?saldoCSL73:proyCS),
                                               (i==0?saldoVivL73:proyViv),
                                               pf.getProySalariosReales()[i],
                                               ci.getSalariosCSproy()[i],
                                               tasaBimestralRCVyCS[i],
                                               tasaBimestralVivienda[i],
                                               capitalizacionAportRCVyCS[i],
                                               capitalizacionAportViv[i],
                                               comisionSobreSaldo[i]);

            resumenMte[i][1] = fm.sumaVector(ci.getSaldoPromRCVPensionados());

            resumenMte[i][2] = fm.sumaVector(ci.getSaldoPromCSPensionados());

            resumenMte[i][3] = fm.sumaVector(ci.getSaldoPromVivPensionados());


            /***************************************************************************
             * Proyección de las pensiones por incapacidad con caracter de temporal.   *
             ***************************************************************************/

            /******************************************************************************************
             * Proyectamos los asegurados y pensionados de incapacidad = 100% temporales en cada año. *
             ******************************************************************************************/
            pa.obtenerProyeccionPensionadosTemporales((i==0?asegbase:asegVig),
                                              probSobrevivenciaAseg,
                                              distViudas,
                                              distOrfandad,
                                              distAscendientes,
                                              pa.getProbActivosMte(),
                                              pa.getProbHuefanos(),
                                              probMteCMGInv,
                                              probEntradaPension[0],//IP100%
                                              densidadCotizacion,
                                              ERMte73,
                                              ERTemp73[i],
                                              ERTemDef73[i],
                                              i,
                                              seguro,
                                              "ip100");

            resumenIP100[i][12] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenIP100[i][13] = fm.sumaVector(pa.getPensionadosTempFinalAnio()[0]);

            resumenIP100[i][14] = pa.getPensionadosSobAnioCompIP100Temp()[i];

            resumenIP100[i][15] = pa.getPensionadosTemDefIP100Temp()[i];

            resumenIP100[i][16] = pa.getPensionadosTemDefFinaAnioIP100Temp()[i];

            resumenIP100[i][21] = pa.getTotalPensionesViudezVigentesIP100Temp()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenIP100[i][22] = pa.getTotalPensionesOrfandadVigentesIP100Temp()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenIP100[i][23] = pa.getTotalPensionesAscendenciaVigentesIP100Temp()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);

            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               (sexo=='H'?Constantes.PORC_VAL_IGUAL_100H:Constantes.PORC_VAL_IGUAL_100M),
                               "ip100",
                               seguro);


            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitularesTemporales(pa.getPensionadosTempFinalAnio(),
                                                          pa.getPensionadosTempFallecidos(),
                                                          pf.getCuantiaPromPensionados(),
                                                          i,
                                                          "ip100",
                                                          seguro);

            resumenIP100[i][17] = pf.getVolPenFinAnio();

            resumenIP100[(i+1<resumenIP100.length?i+1:resumenIP100.length-1)][18] = pf.getVolPenTempSobaniocompleto();

            resumenIP100[(i+2<resumenIP100.length?i+2:resumenIP100.length-1)][19] = pf.getVolPensTemDefMitadAnio();

            resumenIP100[(i+2<resumenIP100.length?i+2:resumenIP100.length-1)][20] = pf.getVolPensTemDefFinalAnio()+ pf.getVolumenPensTemDefFinalAnioIP100()[(i+3<resumenIP100.length?i+3:resumenIP100.length-1)];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distViudas,
                                                    pa.getViudasSobrevivenCadaAnio(),
                                                    pa.getViudasSobrevivenFinalAnio(),
                                                    pa.getNuevasviudasFallecenMitadAnio(),
                                                    pa.getViudasFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCtiaPromViudasDecimoCuarto(),
                                                    i,
                                                    'v',
                                                    "ip100",
                                                    seguro);

            resumenIP100[i][24] = pf.getVolumenPensionViudasTempIP100()[i];

            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distOrfandad,
                                                    pa.getHuerfanosSobrevivenCadaAnio(),
                                                    pa.getHuerfanosSobrevivenFinalAnio(),
                                                    pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                    pa.getHuerfanosFallecenCadaAnio(),
                                                    pa.getProbHuefanos(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'h',
                                                    "ip100",
                                                    seguro);

            resumenIP100[i][25] = pf.getVolumenPensionHuerfanosTempIP100()[i];

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distAscendientes,
                                                    pa.getAscendientesSobrevivenCadaAnio(),
                                                    pa.getAscendientesSobrevivenFinalAnio(),
                                                    pa.getNuevosAscendientesFallecenMitadAnio(),
                                                    pa.getAscendientesFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'a',
                                                    "ip100",
                                                    seguro);

            resumenIP100[i][26] = pf.getVolumenPensionAscendientesTempIP100()[i];
            
            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionadosTemp((i==0?asegbase:asegVig),
                                                     pa.getAseguradosCotizan(),
                                                     pa.getPensionadosMitadAnio(),
                                                     pa.getPensionadosTempFinalAnio(),
                                                     (i==0?saldoRCVL73:proyRCV),
                                                     (i==0?saldoCSL73:proyCS),
                                                     (i==0?saldoVivL73:proyViv),
                                                     distViudas,
                                                     distOrfandad,
                                                     distAscendientes,
                                                     pa.getNuevasViudasCadaAnio(),
                                                     pa.getNuevosHuerfanosCadaAnio(),
                                                     pa.getNuevosAscendientesCadaAnio(),
                                                     pf.getProySalariosReales()[i],
                                                     ci.getSalariosCSproy()[i],
                                                     tasaBimestralRCVyCS,
                                                     tasaBimestralVivienda,
                                                     tasaAnualRCVyCS,
                                                     tasaAnualVivienda,
                                                     comisionSobreSaldo,
                                                     capitalizacionAportRCVyCS[i],
                                                     capitalizacionAportViv[i],
                                                     i,
                                                     "ip100");

            resumenIP100[i][27] = ci.getSaldoCITempRCVIP100()[i];

            resumenIP100[i][28] = ci.getSaldoCITempCSIP100()[i];

            resumenIP100[i][29] = ci.getSaldoCITempVivIP100()[i];

            resumenIP100[i][30] = ci.getSaldoCITempDefRCVIP100()[i];

            resumenIP100[i][31] = ci.getSaldoCITempDefCSIP100()[i];

            resumenIP100[i][32] = ci.getSaldoCITempDefVivIP100()[i];

            /****************************************************************************************************************
             * Proyectamos los asegurados y pensionados de incapacidad menor al 100% y mayor al 50% temporales en cada año. *
             ****************************************************************************************************************/
            pa.obtenerProyeccionPensionadosTemporales((i==0?asegbase:asegVig),
                                                      probSobrevivenciaAseg,
                                                      distViudas,
                                                      distOrfandad,
                                                      distAscendientes,
                                                      pa.getProbActivosMte(),
                                                      pa.getProbHuefanos(),
                                                      probMteCMGInv,
                                                      probEntradaPension[1],//IPMENOR100%
                                                      densidadCotizacion,
                                                      ERMte73,
                                                      ERTemp73[i],
                                                      ERTemDef73[i],
                                                      i,
                                                      seguro,
                                                      "ipMenor100");

            resumenIPMenor100[i][12] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenIPMenor100[i][13] = fm.sumaVector(pa.getPensionadosTempFinalAnio()[0]);

            resumenIPMenor100[i][14] = pa.getPensionadosSobAnioCompIPMenor100Temp()[i];

            resumenIPMenor100[i][15] = pa.getPensionadosTemDefIPMenor100Temp()[i];

            resumenIPMenor100[i][16] = pa.getPensionadosTemDefFinaAnioIPMenor100Temp()[i];

            resumenIPMenor100[i][21] = pa.getTotalPensionesViudezVigentesIPMenor100Temp()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenIPMenor100[i][22] = pa.getTotalPensionesOrfandadVigentesIPMenor100Temp()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenIPMenor100[i][23] = pa.getTotalPensionesAscendenciaVigentesIPMenor100Temp()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);

            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               (sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M),
                               "ipMenor100",
                               seguro);


            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitularesTemporales(pa.getPensionadosTempFinalAnio(),
                                                          pa.getPensionadosTempFallecidos(),
                                                          pf.getCuantiaPromPensionados(),
                                                          i,
                                                          "ipMenor100",
                                                          seguro);

            resumenIPMenor100[i][17] = pf.getVolPenFinAnio();

            resumenIPMenor100[(i+1<resumenIPMenor100.length?i+1:resumenIPMenor100.length-1)][18] = pf.getVolPenTempSobaniocompleto();

            resumenIPMenor100[(i+2<resumenIPMenor100.length?i+2:resumenIPMenor100.length-1)][19] = pf.getVolPensTemDefMitadAnio();

            resumenIPMenor100[(i+2<resumenIPMenor100.length?i+2:resumenIPMenor100.length-1)][20] = pf.getVolPensTemDefFinalAnio()+ pf.getVolumenPensTemDefFinalAnioIPMenor100()[(i+3<resumenIPMenor100.length?i+3:resumenIPMenor100.length-1)];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distViudas,
                                                    pa.getViudasSobrevivenCadaAnio(),
                                                    pa.getViudasSobrevivenFinalAnio(),
                                                    pa.getNuevasviudasFallecenMitadAnio(),
                                                    pa.getViudasFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCtiaPromViudasDecimoCuarto(),
                                                    i,
                                                    'v',
                                                    "ipMenor100",
                                                    seguro);

            resumenIPMenor100[i][24] = pf.getVolumenPensionViudasTempIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);


            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distOrfandad,
                                                    pa.getHuerfanosSobrevivenCadaAnio(),
                                                    pa.getHuerfanosSobrevivenFinalAnio(),
                                                    pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                    pa.getHuerfanosFallecenCadaAnio(),
                                                    pa.getProbHuefanos(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'h',
                                                    "ipMenor100",
                                                    seguro);

            resumenIPMenor100[i][25] = pf.getVolumenPensionHuerfanosTempIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distAscendientes,
                                                    pa.getAscendientesSobrevivenCadaAnio(),
                                                    pa.getAscendientesSobrevivenFinalAnio(),
                                                    pa.getNuevosAscendientesFallecenMitadAnio(),
                                                    pa.getAscendientesFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'a',
                                                    "ipMenor100",
                                                    seguro);

            resumenIPMenor100[i][26] = pf.getVolumenPensionAscendientesTempIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionadosTemp((i==0?asegbase:asegVig),
                                                     pa.getAseguradosCotizan(),
                                                     pa.getPensionadosMitadAnio(),
                                                     pa.getPensionadosTempFinalAnio(),
                                                     (i==0?saldoRCVL73:proyRCV),
                                                     (i==0?saldoCSL73:proyCS),
                                                     (i==0?saldoVivL73:proyViv),
                                                     distViudas,
                                                     distOrfandad,
                                                     distAscendientes,
                                                     pa.getNuevasViudasCadaAnio(),
                                                     pa.getNuevosHuerfanosCadaAnio(),
                                                     pa.getNuevosAscendientesCadaAnio(),
                                                     pf.getProySalariosReales()[i],
                                                     ci.getSalariosCSproy()[i],
                                                     tasaBimestralRCVyCS,
                                                     tasaBimestralVivienda,
                                                     tasaAnualRCVyCS,
                                                     tasaAnualVivienda,
                                                     comisionSobreSaldo,
                                                     capitalizacionAportRCVyCS[i],
                                                     capitalizacionAportViv[i],
                                                     i,
                                                     "ipMenor100");

            resumenIPMenor100[i][27] = ci.getSaldoCITempRCVIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][28] = ci.getSaldoCITempCSIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][29] = ci.getSaldoCITempVivIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][30] = ci.getSaldoCITempDefRCVIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][31] = ci.getSaldoCITempDefCSIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            resumenIPMenor100[i][32] = ci.getSaldoCITempDefVivIPMenor100()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_100H:Constantes.PORC_VAL_MENOR_100M);

            /*************************************************************************************************
             * Proyectamos los asegurados y pensionados de incapacidad menor al 50%  temporales en cada año. *
             *************************************************************************************************/
            pa.obtenerProyeccionPensionadosTemporales((i==0?asegbase:asegVig),
                                                      probSobrevivenciaAseg,
                                                      distViudas,
                                                      distOrfandad,
                                                      distAscendientes,
                                                      pa.getProbActivosMte(),
                                                      pa.getProbHuefanos(),
                                                      probMteCMGInv,
                                                      probEntradaPension[2],//IPMENOR50%
                                                      densidadCotizacion,
                                                      ERMte73,
                                                      ERTemp73[i],
                                                      ERTemDef73[i],
                                                      i,
                                                      seguro,
                                                      "ipMenor50");

            resumenIPMenor50[i][12] = fm.sumaVector(fm.sumaMatriz(pa.getPensionadosMitadAnio()));

            resumenIPMenor50[i][13] = fm.sumaVector(pa.getPensionadosTempFinalAnio()[0]);

            resumenIPMenor50[i][14] = pa.getPensionadosSobAnioCompIPMenor50Temp()[i];

            resumenIPMenor50[i][15] = pa.getPensionadosTemDefIPMenor50Temp()[i];

            resumenIPMenor50[i][16] = pa.getPensionadosTemDefFinaAnioIPMenor50Temp()[i];

            resumenIPMenor50[i][21] = pa.getTotalPensionesViudezVigentesIPMenor50Temp()[i] + fm.sumaVector(pa.getViudasSobrevivenFinalAnio()[0]);

            resumenIPMenor50[i][22] = pa.getTotalPensionesOrfandadVigentesIPMenor50Temp()[i] + fm.sumaVector(pa.getHuerfanosSobrevivenFinalAnio()[0]);

            resumenIPMenor50[i][23] = pa.getTotalPensionesAscendenciaVigentesIPMenor50Temp()[i] + fm.sumaVector(pa.getAscendientesSobrevivenFinalAnio()[0]);

            /********************************************************************************
             * Proyectamos las cuantias para pensionados, viudas, huerfanos y ascendientes. *
             ********************************************************************************/

            pf.obtenerCuantias(art167LSS,
                               pa.getPensionadosMitadAnio(),
                               pf.getSalarioPromedio()[i],
                               pf.getProySalariosReales()[i],
                               pf.getSalMinDiarioNominal()[i],
                               pf.getInflacionAnualAcumulada()[i],
                               pf.getSalariosReales()[i],
                               (sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M),
                               "ipMenor50",
                               seguro);

            /********************************************************
             * Obtenemos los volumenes de pensiones para titulares. *
             ********************************************************/
            pf.obtenerVolumenPensionesTitularesTemporales(pa.getPensionadosTempFinalAnio(),
                                                          pa.getPensionadosTempFallecidos(),
                                                          pf.getCuantiaPromPensionados(),
                                                          i,
                                                          "ipMenor50",
                                                          seguro);

            resumenIPMenor50[i][17] = pf.getVolPenFinAnio();

            resumenIPMenor50[(i+1<resumenIPMenor50.length?i+1:resumenIPMenor50.length-1)][18] = pf.getVolPenTempSobaniocompleto();

            resumenIPMenor50[(i+2<resumenIPMenor50.length?i+2:resumenIPMenor50.length-1)][19] = pf.getVolPensTemDefMitadAnio();

            resumenIPMenor50[(i+2<resumenIPMenor50.length?i+2:resumenIPMenor50.length-1)][20] = pf.getVolPensTemDefFinalAnio()+ pf.getVolumenPensTemDefFinalAnioIPMenor50()[(i+3<resumenIPMenor50.length?i+3:resumenIPMenor50.length-1)];

            /********************************************************************
             * Obtenemos los volumenes de pension para las pensiones derivadas. *
             ********************************************************************/

            /*************************************
             * Volumen de pensiones para viudas. *
             *************************************/
            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distViudas,
                                                    pa.getViudasSobrevivenCadaAnio(),
                                                    pa.getViudasSobrevivenFinalAnio(),
                                                    pa.getNuevasviudasFallecenMitadAnio(),
                                                    pa.getViudasFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCtiaPromViudasDecimoCuarto(),
                                                    i,
                                                    'v',
                                                    "ipMenor50",
                                                    seguro);

            resumenIPMenor50[i][24] = pf.getVolumenPensionViudasTempIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);


            /*************************************¨**
             * Volumen de pensiones para huerfanos. *
             ****************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distOrfandad,
                                                    pa.getHuerfanosSobrevivenCadaAnio(),
                                                    pa.getHuerfanosSobrevivenFinalAnio(),
                                                    pa.getNuevosHuerfanosFallecenMitadAnio(),
                                                    pa.getHuerfanosFallecenCadaAnio(),
                                                    pa.getProbHuefanos(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'h',
                                                    "ipMenor50",
                                                    seguro);

            resumenIPMenor50[i][25] = pf.getVolumenPensionHuerfanosTempIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            /*******************************************
             * Volumen de pensiones para ascendientes. *
             *******************************************/

            pf.obtenerVolumenPensionesDerivadasTemp(pa.getPensionadosFallecidos(),
                                                    distAscendientes,
                                                    pa.getAscendientesSobrevivenCadaAnio(),
                                                    pa.getAscendientesSobrevivenFinalAnio(),
                                                    pa.getNuevosAscendientesFallecenMitadAnio(),
                                                    pa.getAscendientesFallecenCadaAnio(),
                                                    pa.getProbActivosMte(),
                                                    pf.getCuantiaPromHuerfyAsc(),
                                                    i,
                                                    'a',
                                                    "ipMenor50",
                                                    seguro);

            resumenIPMenor50[i][26] = pf.getVolumenPensionAscendientesTempIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            /****************************************************************
             *               Proyeccion de la cuenta individual             *
             ****************************************************************/

            ci.proyectarSaldosCtaIndPensionadosTemp((i==0?asegbase:asegVig),
                                                     pa.getAseguradosCotizan(),
                                                     pa.getPensionadosMitadAnio(),
                                                     pa.getPensionadosTempFinalAnio(),
                                                     (i==0?saldoRCVL73:proyRCV),
                                                     (i==0?saldoCSL73:proyCS),
                                                     (i==0?saldoVivL73:proyViv),
                                                     distViudas,
                                                     distOrfandad,
                                                     distAscendientes,
                                                     pa.getNuevasViudasCadaAnio(),
                                                     pa.getNuevosHuerfanosCadaAnio(),
                                                     pa.getNuevosAscendientesCadaAnio(),
                                                     pf.getProySalariosReales()[i],
                                                     ci.getSalariosCSproy()[i],
                                                     tasaBimestralRCVyCS,
                                                     tasaBimestralVivienda,
                                                     tasaAnualRCVyCS,
                                                     tasaAnualVivienda,
                                                     comisionSobreSaldo,
                                                     capitalizacionAportRCVyCS[i],
                                                     capitalizacionAportViv[i],
                                                     i,
                                                     "ipMenor50");

            resumenIPMenor50[i][27] = ci.getSaldoCITempRCVIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][28] = ci.getSaldoCITempCSIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][29] = ci.getSaldoCITempVivIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][30] = ci.getSaldoCITempDefRCVIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][31] = ci.getSaldoCITempDefCSIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            resumenIPMenor50[i][32] = ci.getSaldoCITempDefVivIPMenor50()[i]*(sexo=='H'?Constantes.PORC_VAL_MENOR_50H:Constantes.PORC_VAL_MENOR_50M);

            //guardan variables a utilizar el siguiente año
            asegVig = pa.getAseguradosVigentes();
            proyRCV = ci.getRcvProyectada();
            proyCS = ci.getCsProyectada();
            proyViv = ci.getVivProyectada();
            
        }

         if(!latxt.existeArchivo(directorioSalida,archivoSalida+".ods")){
             lecEscHojCalc.crearArchivoExcel(directorioFormato, archivoFormato,".xls");
             lecEscHojCalc.guardarLibroOpenOffice(directorioSalida, archivoSalida);
         }

        System.out.println("Guardando los resultados de la proyeccion RT");

        lecEscHojCalc.crearArchivoExcel(directorioSalida, archivoSalida, ".ods");
        lecEscHojCalc.crearHojaExcel("IP=100_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenIP100, 5, 2,"##.#####");
        lecEscHojCalc.crearHojaExcel("50<IP<100_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenIPMenor100, 5, 2, "##.#####");
        lecEscHojCalc.crearHojaExcel("IP<50_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenIPMenor50, 5, 2, "##.#####");
        lecEscHojCalc.crearHojaExcel("Muerte_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenMte, 5, 2, "##.#####");
        lecEscHojCalc.guardarLibroOpenOffice(directorioSalida, archivoSalida);

    }
    
}
