/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SRT;

/**
 *
 * @author Antonio-Alcalde
 */

import ProyeccionPensionados.Constantes;
import Librerias.*;
import Stock.ProyeccionDemograficaStock;
import Stock.ProyeccionFinancieraStock;


public class StockSRT {

    public void obtenerStockSRT(char sexo,String seguro){

        double[][] costosUnitRedimTit;
        double[][] costosUnitRedimEsp;
        double[][] distViudas;
        double[][] distHuerfanos;
        double[][] distAscendientes;
        double[][] probSobViudas;
        double[][] probSobHuerfanos;
        double[][] probSobAscendientes;
        double[]   casosIP100;
        double[]   casosIPMenor100;
        double[]   casosViudezIPMenor100;
        double[]   casosOrfandadIPMenor100;
        double[]   casosAscendientesIPMenor100;
        double[]   probMteInvalidos;        
        double[]   costosUnitariosTit;
        double[]   costosUnitariosEsp;
        double[]   costosUnitariosDer;        
        double[]   cuantiaIP100;
        double[]   cuantiaIPMenor100;
        double[]   cuantiaViudezIPMenor100;
        double[]   cuantiaOrfandadIPMenor100;
        double[]   cuantiaAscendenciaIPMenor100;
        double[]   gmpPensionados = new double[Constantes.ANIOS_PROYECCION-1];
        double[]   gmpDerivadas = new double[Constantes.ANIOS_PROYECCION-1];
        double[]   volumenPensionTitularesIP100 = new double[Constantes.ANIOS_PROYECCION-1];
        double[]   volumenPensionTitularesIPMenor100 = new double[Constantes.ANIOS_PROYECCION-1];
        double[][] resumenRTGMP = new double[Constantes.ANIOS_PROYECCION-1][8];
        double[][] resumenRTDemFin = new double[Constantes.ANIOS_PROYECCION-1][16];


        /************************************************************************
         *    Se crean los objetos que se requieren en la proyeccion del SIV    *
         ************************************************************************/
        LecturaEscrituraHojasCalculo lecEscHojCalc = new LecturaEscrituraHojasCalculo();
        FuncionesMatematicas fm = new FuncionesMatematicas();
        ProyeccionDemograficaStock proyDem = new ProyeccionDemograficaStock();
        ProyeccionFinancieraStock proyFin = new ProyeccionFinancieraStock();
        LecturaArchivoTxt latxt = new LecturaArchivoTxt();

        /***************************************************************************************************
         *   Direccion en la que se encuentran los archivos, que el programa va tomar para procesarlos.     *
         ****************************************************************************************************/
        String directorioArchivoEntradas = Constantes.DIRECTORIO_DATOS_ENTRADA;
        String directorioFormato = Constantes.DIRECTORIO_FORMATO;
        String directorioSalida = Constantes.DIRECTORIO_SALIDA;
        String archivoEntradas = Constantes.NOMBRE_ARCHIVO_ENTRADA;
        String archivoSalida = Constantes.NOMBRE_ARCHIVO_SALIDA_RT;
        String archivoFormato = Constantes.NOMBRE_ARCHIVO_FORMATO_RT;

        /*************************************************************************
         *Obtención de parametros de entrada del SIV para realizar la proyección *
         *************************************************************************/

        lecEscHojCalc.abrirArchivoExcel(directorioArchivoEntradas,archivoEntradas, ".xls");

        if(sexo == Constantes.HOMBRE){

            casosIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 4,3,96);//ok
            casosIP100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 4,7,96);//ok
            casosViudezIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 105,4,96);//ok
            casosOrfandadIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 105,5,96);//ok
            casosAscendientesIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 105,6,96);//ok
            probMteInvalidos = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockBiometricas", 4,3,96);//ok
            costosUnitariosTit = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,3,111);//ok
            costosUnitariosEsp = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,4,111);//ok
            costosUnitariosDer = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,5,111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 4, 2, 96, 96);
            distHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 4, 2, 96, 96);
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 4, 2, 96, 96);
            probSobViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 101, 100, 96);
            probSobHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 106, 101, 100, 96);
            probSobAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 106, 101, 100, 96);
            cuantiaIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,8,96);//ok
            cuantiaIP100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,12,96);//ok
            cuantiaViudezIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 106,9,96);//ok
            cuantiaOrfandadIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 106,10,96);//ok
            cuantiaAscendenciaIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 106,11,96);//ok



        }else{

            casosIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 4,3,96);//ok
            casosIP100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 4,7,96);//ok
            casosViudezIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 105,4,96);//ok
            casosOrfandadIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 105,5,96);//ok
            casosAscendientesIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockDemRT", 105,6,96);//ok
            probMteInvalidos = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockBiometricas", 4,3,96);//ok
            costosUnitariosTit = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,3,111);//ok
            costosUnitariosEsp = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,4,111);//ok
            costosUnitariosDer = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,5,111);//ok
            distViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 4, 2, 96, 96);
            distHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 4, 2, 96, 96);
            distAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 4, 2, 96, 96);
            probSobViudas = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisViu", 106, 101, 100, 96);
            probSobHuerfanos = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisHuerf", 106, 101, 100, 96);
            probSobAscendientes = (double[][]) lecEscHojCalc.leerHojaExcel("StockDisAsc", 106, 101, 100, 96);
            cuantiaIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,8,96);//ok
            cuantiaIP100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 4,12,96);//ok
            cuantiaViudezIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 106,9,96);//ok
            cuantiaOrfandadIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 106,10,96);//ok
            cuantiaAscendenciaIPMenor100 = (double[]) lecEscHojCalc.leerVectorHojaExcel("StockFinancierasRT", 106,11,96);


        }

            /************************************************************************
             *Proyeccion del Stock de pensionados del Seguro de Riesgos de Trabajo  *
             ************************************************************************/        
        /*********************************************************
         *  Stock de pensionados por Incapacidad menor a 100%    *
         *********************************************************/
        System.out.println("Inicia proyeccion del Stock del SRT");

        proyDem.obtenerPensionadosSobrevivientes(casosIPMenor100,
                                                 probMteInvalidos);

        resumenRTDemFin[0] = fm.sumaMatriz(proyDem.getPensionadosSobrevivientes());//resumenDemografico


        proyDem.obtenerPensionadosFallecidos(proyDem.getPensionadosSobrevivientes(),
                                             probMteInvalidos);

        //Costos Unitarios titulares
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimTit = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);

        //Obtenemos las GMP de los pensionados
        for(int año=0;año<resumenRTGMP.length;año++){
            resumenRTGMP[año][0] = (fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosSobrevivientes()[año]) +
                                  fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosFallecidos()[año])/2D)/1000000D;
        }         

        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosEsp,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevas Viudas
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distViudas);

        //VIudas Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobViudas));


        //Obtenemos las viudas sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobViudas));


        //Obtenemos el Stock de las viudas sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobViudas),
                                         casosViudezIPMenor100,
                                         false);//No es IP menor a 100

        /*******************************************************************************************
         *                              Obtenemos la GMP de las viudas *
         *******************************************************************************************/

        for(int año=0;año<resumenRTGMP.length;año++){                  //***este
            resumenRTGMP[año][1] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                (fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año])/2D) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }



        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenRTDemFin[1] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico


        proyFin.obtenerCuantiaPensionados(cuantiaIPMenor100);


                               /**Obtenemos el volumen de pensiones de invalidez*/
        //Primer año
        volumenPensionTitularesIPMenor100[0] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[0], proyFin.getCuantiaPensionados()[0]) * 12)/1000000D;

        //demas años
        for(int año=1;año<volumenPensionTitularesIPMenor100.length;año++){
            volumenPensionTitularesIPMenor100[año] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[año], proyFin.getCuantiaPensionados()[año]) * 12)/1000000D +
                                           (fm.sumaProducto(proyDem.getPensionadosFallecidos()[año], proyFin.getCuantiaPensionados()[año]) * 6)/1000000D;
        }


        resumenRTDemFin[4] = volumenPensionTitularesIPMenor100;//Resumen financiero


        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     true,//si es viuda
                                                     true);// si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distViudas);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaViudezIPMenor100);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenRTDemFin[5] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero



        /**********************************************************************
         *              Proyeccion de los huefanos de Invalidez               *
         **********************************************************************/

        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosDer,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    0);
        //Nuevos huefanos
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distHuerfanos);

        //huefanos Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobHuerfanos));

        //Obtenemos los huefanos sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobHuerfanos));

        //double aux = fm.sumaVector(fm.sumaMatriz(proyDem.getDerivadasSobSinNuevas()));

        //Obtenemos el Stock de los huefanos sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobHuerfanos),
                                         casosOrfandadIPMenor100,
                                         false);//No es IP 100%;

        /*******************************************************************************************
         *                              Obtenemos la GMP de los huerfanos                          *
         *******************************************************************************************/
        for(int año=0;año<resumenRTGMP.length;año++){
            resumenRTGMP[año][2] =((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año]) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenRTDemFin[2] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distHuerfanos);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaOrfandadIPMenor100);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenRTDemFin[6] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero




        /**********************************************************************
         *              Proyeccion de los ascendientes de Invalidez           *
         **********************************************************************/

        //Costos Unitarios ascendientes(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevos ascendientes
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distAscendientes);

        //ascendientes Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobAscendientes));

        //Obtenemos los ascendientes sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobAscendientes));

        //Obtenemos el Stock de los ascendientes sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobAscendientes),
                                         casosAscendientesIPMenor100,
                                         false);//No es IP 100%;

        /*******************************************************************************************
         *                              Obtenemos la GMP de los ascendientes                          *
         *******************************************************************************************/
        for(int año=0;año<resumenRTGMP.length;año++){
            resumenRTGMP[año][3] =((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año]) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenRTDemFin[3] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distAscendientes);


        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaAscendenciaIPMenor100);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenRTDemFin[7] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero



        /****************************************************************************
         *          Proyeccion de Incapacidad permanente al 100%                    *   :) :) :)
         ****************************************************************************/


        /*****************************************
         *  Stock de pensionados por IP=100%     *
         *****************************************/

        proyDem.obtenerPensionadosSobrevivientes(casosIP100,
                                                 probMteInvalidos);


        resumenRTDemFin[8] = fm.sumaMatriz(proyDem.getPensionadosSobrevivientes());//resumenDemografico


        proyDem.obtenerPensionadosFallecidos(proyDem.getPensionadosSobrevivientes(),
                                             probMteInvalidos);

        //Costos Unitarios titulares
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimTit = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);

        //Obtenemos las GMP de los pensionados
        for(int año=0;año<resumenRTGMP.length;año++){
            resumenRTGMP[año][4] = (fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosSobrevivientes()[año]) +
                                  fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosFallecidos()[año])/2D)/1000000D;
        }
        

        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosEsp,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevas Viudas
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distViudas);

        //VIudas Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobViudas));


        //Obtenemos las viudas sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobViudas));

        //Obtenemos el Stock de las viudas sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobViudas),
                                         casosViudezIPMenor100,//puede o no ir
                                         true);//Es IP100);




        /*******************************************************************************************
         *                              Obtenemos la GMP de las viudas *
         *******************************************************************************************/

        for(int año=0;año<resumenRTGMP.length;año++){                  //***este
            resumenRTGMP[año][5] =((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año]) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }



        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenRTDemFin[9] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico


        proyFin.obtenerCuantiaPensionados(cuantiaIP100);


                               /**Obtenemos el volumen de pensiones de IP100%*/
        //Primer año
        volumenPensionTitularesIP100[0] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[0], proyFin.getCuantiaPensionados()[0]) * 12)/1000000D;

        //demas años
        for(int año=1;año<volumenPensionTitularesIP100.length;año++){
            volumenPensionTitularesIP100[año] = (fm.sumaProducto(proyDem.getPensionadosSobrevivientes()[año], proyFin.getCuantiaPensionados()[año]) * 12)/1000000D +
                                           (fm.sumaProducto(proyDem.getPensionadosFallecidos()[año], proyFin.getCuantiaPensionados()[año]) * 6)/1000000D;
        }


        resumenRTDemFin[12] = volumenPensionTitularesIP100;//Resumen financiero


        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     true,//si es viuda
                                                     true);// si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distViudas);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaViudezIPMenor100);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenRTDemFin[13] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero



        /**********************************************************************
         *              Proyeccion de los huefanos de IP=100%                  *
         **********************************************************************/

        //Costos Unitarios titulares
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimTit = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);

        //Obtenemos las GMP de los pensionados
        for(int año=0;año<gmpPensionados.length;año++){
            gmpPensionados[año] = fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosSobrevivientes()[año]) +
                                  fm.sumaProducto(costosUnitRedimTit[año], proyDem.getPensionadosFallecidos()[año])/2D;
        }

        //resumenIVGMP[0] = gmpPensionados;//resumen GMP

        //Costos Unitarios Viudo(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosEsp,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevos huefanos
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distHuerfanos);

        //huefanos Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobHuerfanos));

        //Obtenemos los huefanos sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobHuerfanos));

        //Obtenemos el Stock de los huefanos sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobHuerfanos),
                                         casosOrfandadIPMenor100,
                                         true);//Es IP 100%

        /*******************************************************************************************
         *                              Obtenemos la GMP de los huerfanos                          *
         *******************************************************************************************/
        for(int año=0;año<resumenRTGMP.length;año++){
            resumenRTGMP[año][6] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año]) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenRTDemFin[10] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distHuerfanos);

        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaOrfandadIPMenor100);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenRTDemFin[14] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero




        /**********************************************************************
         *              Proyeccion de los ascendientes de CeVe           *
         **********************************************************************/

        //Costos Unitarios ascendientes(a)
        proyFin.obtenerCostosUnitarios(costosUnitariosTit,
                                       Constantes.PORC_COSTO_UNITARIO);

        costosUnitRedimEsp = fm.redimensionarMatriz(proyFin.getCostosUnitarios(),
                                                    proyDem.getPensionadosSobrevivientes().length,
                                                    proyDem.getPensionadosSobrevivientes()[0].length,
                                                    15);
        //Nuevos ascendientes
        proyDem.obtenerNuevasDerivadas(proyDem.getPensionadosFallecidos(),
                                       distAscendientes);

        //ascendientes Sobrevivientes Final Anio
        proyDem.obtenerNuevasDerivadasSobFinAnio(proyDem.getNuevasDerivadas(),
                                                 fm.transponer(probSobAscendientes));

        //Obtenemos los ascendientes sobrevivientes sin nuevas
        proyDem.obtenerDerivadasSobSinNuevas(proyDem.getDerivadasSobFinAnio(),
                                             fm.transponer(probSobAscendientes));

        //Obtenemos el Stock de los ascendientes sobrevivientes
        proyDem.obtenerStockDerivadasSob(proyDem.getDerivadasSobSinNuevas(),
                                         fm.transponer(probSobAscendientes),
                                         casosAscendientesIPMenor100,
                                         true);//Es CeVe);

        /*******************************************************************************************
         *                              Obtenemos la GMP de los ascendientes                          *
         *******************************************************************************************/
        for(int año=0;año<resumenRTGMP.length;año++){
            resumenRTGMP[año][7] = ((fm.sumaProducto(proyDem.getStockDerivadasSob()[año], costosUnitRedimEsp[año])) +
                                fm.sumaProducto(proyDem.getDerivadasSobSinNuevas()[año], costosUnitRedimEsp[año]) +
                                (fm.sumaProducto(proyDem.getDerivadasSobFinAnio()[año], costosUnitRedimEsp[año])/2D))/1000000D;
        }

        proyDem.obtenerTotalDerivadas(proyDem.getStockDerivadasSob(),
                                      proyDem.getDerivadasSobSinNuevas(),
                                      proyDem.getDerivadasSobFinAnio());

        resumenRTDemFin[11] = fm.sumaMatriz(proyDem.getCasosTotalesDerivadas());//Resumen demografico

        proyFin.obtenerCuantiaBasicaPensionados(proyFin.getCuantiaPensionados());

        proyFin.obtenerCuantiaDerivadasPenFallecidos(proyFin.getCuantiaBasicaPensionados(),
                                                     false,//no es viuda
                                                     true);//si es IV

        proyFin.obtenerCuantiaPromedioNuevasDerivadas(proyFin.getCuantiaDerivadasPenFalle(),
                                                      proyDem.getPensionadosFallecidos(),
                                                      proyDem.getNuevasDerivadas(),
                                                      distAscendientes);


        proyFin.obtenerCuantiPromFinalDerivadas(proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                cuantiaAscendenciaIPMenor100);

        proyFin.obtenerCuantiasFinalesDerivadas(proyDem.getDerivadasSobFinAnio(),
                                                proyDem.getDerivadasSobSinNuevas(),
                                                proyDem.getStockDerivadasSob(),
                                                proyFin.getCuantiaPromNuevasDerivadas(),
                                                proyFin.getCuantiaPromFinalDerivadas());

        resumenRTDemFin[15] = fm.sumaMatriz(proyFin.getCuantiaFinalDerivadas());//resumen financiero


        if(!latxt.existeArchivo(directorioSalida,archivoSalida+".ods")){
             lecEscHojCalc.crearArchivoExcel(directorioFormato, archivoFormato,".xls");
             lecEscHojCalc.guardarLibroOpenOffice(directorioSalida, archivoSalida);
         }

        System.out.println("Guardando los resultados de la proyeccion RT");

        lecEscHojCalc.crearArchivoExcel(directorioSalida,archivoSalida, ".ods");
        lecEscHojCalc.crearHojaExcel("Stock_"+sexo);
        lecEscHojCalc.escribirHojasExcel(fm.transponer(resumenRTDemFin), 5, 2, "##.#####");
        lecEscHojCalc.crearHojaExcel("Stock_GMP_"+sexo);
        lecEscHojCalc.escribirHojasExcel(resumenRTGMP, 5, 2, "##.#####");
        lecEscHojCalc.guardarLibroOpenOffice(directorioSalida,archivoSalida);


    }

}
