/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Stock;

/**
 *
 * @author Antonio-Alcalde
 */
import ProyeccionPensionados.Constantes;
import Librerias.FuncionesMatematicas;

public class ProyeccionFinancieraStock {

    private double[][] costosUnitarios;
    private double[][] cuantiaPensionados;
    private double[][] cuantiaBasicaPensionados;
    private double[][] cuantiaDerivadasPenFalle;
    private double[][] cuantiaPromNuevasDerivadas;
    private double[][] cuantiaPromFinalDerivadas;
    private double[][] cuantiaFinalDerivadas;

    public void obtenerCostosUnitarios(double[] costosUnitarios,
                                       double   porCostoUnit){

        double costosUnit[][] = new double[Constantes.ANIOS_PROYECCION-1][costosUnitarios.length];


        //Para el primer año
        costosUnit[0] = costosUnitarios;
        //Para los demas años
        for(int año=1;año<costosUnit.length;año++){
            for(int edad=0;edad<costosUnit[0].length;edad++){
                costosUnit[año][edad] = costosUnit[año-1][edad] * (1D + porCostoUnit);
            }
        }
        this.costosUnitarios = costosUnit;
    }

    public void obtenerCuantiaPensionados(double[] cuantiaPensionados){

        double[][] ctiaPens = new double[Constantes.ANIOS_PROYECCION-1][(Constantes.EDAD_MAX_PROYECTADA-Constantes.EDAD_MIN_PROYECTADA)+1];

        //Para el primer año
        for(int edad=0;edad<cuantiaPensionados.length;edad++){
            ctiaPens[0][edad] = cuantiaPensionados[edad];
        }

        //Para los demas años
        for(int año=1;año<ctiaPens.length;año++){
            for(int edad=1;edad<ctiaPens[0].length;edad++){
                ctiaPens[año][edad] = (edad==45?ctiaPens[año-1][edad-1]*(1+Constantes.CRECIMIENTO_REAL)*Constantes.DECIMO_CUARTO:
                                       ctiaPens[año-1][edad-1]*(1+Constantes.CRECIMIENTO_REAL));
            }
        }
        this.cuantiaPensionados = ctiaPens;

    }

    public void obtenerCuantiaBasicaPensionados(double[][] cuantiaPensionados){

        double[][] ctiaBasica = new double[cuantiaPensionados.length][cuantiaPensionados[0].length];

        for(int año=1;año<ctiaBasica.length;año++){
            for(int edad=0;edad<ctiaBasica[0].length;edad++){
                ctiaBasica[año][edad] = (edad>=45? (cuantiaPensionados[año][edad]/Constantes.DECIMO_CUARTO)/(1.2D+1/12D):
                                         cuantiaPensionados[año][edad]/(1.2D+1/12D));
            }
        }
        this.cuantiaBasicaPensionados = ctiaBasica;
    }

    public void obtenerCuantiaDerivadasPenFallecidos(double[][] ctiaBasica,
                                                     boolean esViuda,
                                                     boolean esIV){

        double[][] ctiaDerivadas = new double[ctiaBasica.length][ctiaBasica[0].length];
        double     SMGDF = Constantes.SALARIO_MIN_STOCK * Constantes.DIAS_ANUAL/12D;
        double     porcentajeCtiaDer = (esViuda & esIV ? Constantes.PORC_VIUDEZIV_STOCK: esViuda & !esIV ? Constantes.PORC_VIUDEZIV_STOCK : Constantes.PORC_CUANTIA_HUERF_ASC);

        if(esViuda){
            for(int año=1;año<ctiaDerivadas.length;año++){
                for(int edad=0;edad<ctiaDerivadas[0].length;edad++){
                    ctiaDerivadas[año][edad] =(ctiaBasica[año][edad] * porcentajeCtiaDer * (1+Constantes.PORC_ASIG_FAMILIARES) <=
                                               SMGDF * Constantes.VECES_SMGDF ?
                                              (ctiaBasica[año][edad] * porcentajeCtiaDer * (1+Constantes.PORC_ASIG_FAMILIARES)+(ctiaBasica[año][edad]/12D)) * Constantes.DECIMO_CUARTO:
                                               ctiaBasica[año][edad] * porcentajeCtiaDer * (1+Constantes.PORC_ASIG_FAMILIARES)+(ctiaBasica[año][edad]/12D));
                }
            }                        
        }else{//Huerfanos y acendientes
                for(int año=1;año<ctiaDerivadas.length;año++){
                    for(int edad=0;edad<ctiaDerivadas[0].length;edad++){
                        ctiaDerivadas[año][edad] = (ctiaBasica[año][edad] * porcentajeCtiaDer)  * Constantes.DECIMO_CUARTO;
                    }
                }
        }
        this.cuantiaDerivadasPenFalle = ctiaDerivadas;
    }

    public void obtenerCuantiaPromedioNuevasDerivadas(double[][] ctiaDerivadasFalle,
                                                      double[][] pensFallecidos,
                                                      double[][] nuevasDerivadas,
                                                      double[][] distDerivadas){

        double[][] ctiaPromNuevasDer = new double[ctiaDerivadasFalle.length][ctiaDerivadasFalle[0].length];

        FuncionesMatematicas fm = new FuncionesMatematicas();

        for(int año=1;año<ctiaPromNuevasDer.length;año++){
            for(int edad=0;edad<ctiaPromNuevasDer[0].length;edad++){
                ctiaPromNuevasDer[año][edad] = (nuevasDerivadas[año][edad] ==0 ? 0 :
                        fm.sumaProducto(ctiaDerivadasFalle[año], pensFallecidos[año],distDerivadas[edad])/nuevasDerivadas[año][edad]);
            }
        }
        this.cuantiaPromNuevasDerivadas = ctiaPromNuevasDer;   
    }
    
    public void obtenerCuantiPromFinalDerivadas(double[][] derivadasSobSinNuevas,
                                                double[][] stockSob,
                                                double[][] ctiaPromNuevasDer,
                                                double[]   ctiaEsp){

        double[][] ctiaPromFinal = new double[ctiaPromNuevasDer.length][ctiaPromNuevasDer[0].length];

        //Para el primer año
        for(int edad=0;edad<ctiaEsp.length;edad++){
            ctiaPromFinal[0][edad] = ctiaEsp[edad];
        }
        //Para el segundo año
        for(int edad=1;edad<ctiaPromFinal[0].length;edad++){
            ctiaPromFinal[1][edad] = ctiaPromFinal[0][edad-1];            

        }
        //Para los demas años 
        for(int año=2;año<ctiaPromFinal.length;año++){
            for(int edad=2;edad<ctiaPromFinal[0].length;edad++){
                ctiaPromFinal[año][edad] = (stockSob[año-1][edad-1] + derivadasSobSinNuevas[año-1][edad-1] == 0 ? 0 :
                                            (stockSob[año-1][edad-1] * ctiaPromFinal[año-1][edad-1] + derivadasSobSinNuevas[año-1][edad-1] * ctiaPromNuevasDer[año-2][edad-2])/
                                            (stockSob[año-1][edad-1] + derivadasSobSinNuevas[año-1][edad-1]));
            }
        }
        this.cuantiaPromFinalDerivadas = ctiaPromFinal;        
    }

    public void obtenerCuantiasFinalesDerivadas(double[][] nuevasDerSobFinAnio,
                                                double[][] derivadasSobSinNuevas,
                                                double[][] stockSob,
                                                double[][] ctiaPromNvasDer,
                                                double[][] ctiaPromFinal){

        double[][] ctiasFinDer = new double[ctiaPromFinal.length][ctiaPromFinal[0].length];

        for(int año=1;año<ctiaPromFinal.length;año++){//2010 edad 16
            for(int edad=1;edad<ctiaPromFinal[0].length;edad++){
                ctiasFinDer[año][edad] = ((derivadasSobSinNuevas[año][edad] * ctiaPromNvasDer[año-1][edad-1] * 12D) +
                                         (nuevasDerSobFinAnio[año][edad] * ctiaPromNvasDer[año][edad] * 6D) +
                                         (stockSob[año][edad] * ctiaPromFinal[año][edad]) * 12D) / 1000000D;
            }
        }
        this.cuantiaFinalDerivadas = ctiasFinDer;
    }






    public double[][] getCostosUnitarios() {
        return costosUnitarios;
    }

    public double[][] getCuantiaPensionados() {
        return cuantiaPensionados;
    }

    public double[][] getCuantiaBasicaPensionados() {
        return cuantiaBasicaPensionados;
    }

    public double[][] getCuantiaDerivadasPenFalle() {
        return cuantiaDerivadasPenFalle;
    }

    public double[][] getCuantiaPromNuevasDerivadas() {
        return cuantiaPromNuevasDerivadas;
    }

    public double[][] getCuantiaPromFinalDerivadas() {
        return cuantiaPromFinalDerivadas;
    }

    public double[][] getCuantiaFinalDerivadas() {
        return cuantiaFinalDerivadas;
    }

    
    
    





    

    

    
    

    

    

}
